/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 79 "cfg.y" /* yacc.c:339  */


#include <stdlib.h>
#include <stdio.h>
#include <sys/socket.h>
#include <unistd.h>
#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>
#include <arpa/inet.h>
#include <string.h>
#include <errno.h>
#include "route_struct.h"
#include "globals.h"
#include "route.h"
#include "dprint.h"
#include "cfg_pp.h"
#include "sr_module.h"
#include "modparam.h"
#include "ip_addr.h"
#include "resolve.h"
#include "socket_info.h"
#include "name_alias.h"
#include "ut.h"
#include "pt_scaling.h"
#include "dset.h"
#include "pvar.h"
#include "blacklists.h"
#include "xlog.h"
#include "db/db_insertq.h"
#include "bin_interface.h"
#include "net/trans.h"
#include "config.h"
#include "mem/rpm_mem.h"
#include "poll_types.h"

#ifdef SHM_EXTRA_STATS
#include "mem/module_info.h"
#endif

#ifdef DEBUG_DMALLOC
#include <dmalloc.h>
#endif

/* hack to avoid alloca usage in the generated C file (needed for compiler
 with no built in alloca, like icc*/
#undef _ALLOCA_H

#undef MIN
#undef MAX

extern int yylex();
static void yyerror(char* s);
static void yyerrorf(char* fmt, ...);
static char* tmp;
static int i_tmp, rc;
static struct socket_id* lst_tmp;
static int rt;  /* Type of route block for find_export */
static str s_tmp;
static str tstr;
static struct net* net_tmp;
static pv_spec_t *spec;
static pv_elem_t *elem;
static struct bl_rule *bl_head = 0;
static struct bl_rule *bl_tail = 0;
static struct script_route_ref *rt_ref = NULL;

action_elem_t elems[MAX_ACTION_ELEMS];
static action_elem_t route_elems[MAX_ACTION_ELEMS];
action_elem_t *a_tmp;

static inline void warn(char* s);
static struct socket_id* mk_listen_id(char*, enum sip_protos, int);
static struct socket_id* set_listen_id_adv(struct socket_id *, char *, int);
static struct multi_str *new_string(char *s);
static int parse_ipnet(char *in, int len, struct net **ipnet);

extern int line;
extern int column;
extern int startcolumn;
extern char *finame;

struct listen_param {
	enum si_flags flags;
	int workers;
	struct socket_id *socket;
	char *tag;
	char *auto_scaling_profile;
} p_tmp;
static void fill_socket_id(struct listen_param *param, struct socket_id *s);

union route_name_var {
	int iname;
	struct _pv_spec *sname;
	struct _pv_elem *ename;
	void *data;
} rn_tmp;

#ifndef SHM_EXTRA_STATS
struct multi_str{
	char *s;
	struct multi_str* next;
};
#else
static struct multi_str *tmp_mod;
#endif

#define get_cfg_file_name \
	((finame) ? finame : cfg_file ? cfg_file : "default")



#define mk_action_(_res, _type, _no, _elems) \
	do { \
		_res = mk_action(_type, _no, _elems, line, get_cfg_file_name); \
	} while(0)
#define mk_action0(_res, _type) \
	do { \
		_res = mk_action(_type, 0, 0, line, get_cfg_file_name); \
	} while(0)
#define mk_action1(_res, _type, _p1_type, _p1) \
	do { \
		elems[0].type = _p1_type; \
		elems[0].u.data = _p1; \
		_res = mk_action(_type, 1, elems, line, get_cfg_file_name); \
	} while(0)
#define	mk_action2(_res, _type, _p1_type, _p2_type, _p1, _p2) \
	do { \
		elems[0].type = _p1_type; \
		elems[0].u.data = _p1; \
		elems[1].type = _p2_type; \
		elems[1].u.data = _p2; \
		_res = mk_action(_type, 2, elems, line, get_cfg_file_name); \
	} while(0)
#define mk_action3(_res, _type, _p1_type, _p2_type, _p3_type, _p1, _p2, _p3) \
	do { \
		elems[0].type = _p1_type; \
		elems[0].u.data = _p1; \
		elems[1].type = _p2_type; \
		elems[1].u.data = _p2; \
		elems[2].type = _p3_type; \
		elems[2].u.data = _p3; \
		_res = mk_action(_type, 3, elems, line, get_cfg_file_name); \
	} while(0)

extern int cfg_parse_only_routes;
#define IFOR(_instr) \
	if (cfg_parse_only_routes==1) {_instr;break;}


#line 217 "cfg.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "cfg.tab.h".  */
#ifndef YY_YY_CFG_TAB_H_INCLUDED
# define YY_YY_CFG_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    DROP = 258,
    ASSERT = 259,
    EXIT = 260,
    RETURN = 261,
    LOG_TOK = 262,
    ERROR = 263,
    ROUTE = 264,
    ROUTE_FAILURE = 265,
    ROUTE_ONREPLY = 266,
    ROUTE_BRANCH = 267,
    ROUTE_ERROR = 268,
    ROUTE_LOCAL = 269,
    ROUTE_STARTUP = 270,
    ROUTE_TIMER = 271,
    ROUTE_EVENT = 272,
    IF = 273,
    ELSE = 274,
    SWITCH = 275,
    CASE = 276,
    DEFAULT = 277,
    BREAK = 278,
    WHILE = 279,
    FOR = 280,
    IN = 281,
    READONLY = 282,
    EXPIRE = 283,
    NULLV = 284,
    XDBG = 285,
    XLOG = 286,
    XLOG_BUF_SIZE = 287,
    XLOG_FORCE_COLOR = 288,
    XLOG_PRINT_LEVEL = 289,
    XLOG_LEVEL = 290,
    PV_PRINT_BUF_SIZE = 291,
    DEBUG_MODE = 292,
    ENABLE_ASSERTS = 293,
    ABORT_ON_ASSERT = 294,
    LOGLEVEL = 295,
    LOGPREFIX = 296,
    LOGSTDOUT = 297,
    LOGSTDERROR = 298,
    STDERROR_ENABLED = 299,
    SYSLOG_ENABLED = 300,
    LOG_EVENT_ENABLED = 301,
    STDERROR_LEVEL_FILTER = 302,
    SYSLOG_LEVEL_FILTER = 303,
    STDERROR_FORMAT = 304,
    SYSLOG_FORMAT = 305,
    LOG_JSON_BUF_SIZE = 306,
    LOG_MSG_BUF_SIZE = 307,
    LOGFACILITY = 308,
    SYSLOG_FACILITY = 309,
    LOGNAME = 310,
    SYSLOG_NAME = 311,
    AVP_ALIASES = 312,
    LISTEN = 313,
    SOCKET = 314,
    MEMGROUP = 315,
    ALIAS = 316,
    AUTO_ALIASES = 317,
    TAG = 318,
    DNS = 319,
    REV_DNS = 320,
    DNS_TRY_IPV6 = 321,
    DNS_TRY_NAPTR = 322,
    DNS_RETR_TIME = 323,
    DNS_RETR_NO = 324,
    DNS_SERVERS_NO = 325,
    DNS_USE_SEARCH = 326,
    MAX_WHILE_LOOPS = 327,
    UDP_WORKERS = 328,
    CHECK_VIA = 329,
    SHM_HASH_SPLIT_PERCENTAGE = 330,
    SHM_SECONDARY_HASH_SIZE = 331,
    MEM_WARMING_ENABLED = 332,
    MEM_WARMING_PATTERN_FILE = 333,
    MEM_WARMING_PERCENTAGE = 334,
    RPM_MEM_FILE = 335,
    RPM_MEM_SIZE = 336,
    MEMLOG = 337,
    MEMDUMP = 338,
    SHM_MEMLOG_SIZE = 339,
    EXECMSGTHRESHOLD = 340,
    EXECDNSTHRESHOLD = 341,
    TCPTHRESHOLD = 342,
    EVENT_SHM_THRESHOLD = 343,
    EVENT_PKG_THRESHOLD = 344,
    QUERYBUFFERSIZE = 345,
    QUERYFLUSHTIME = 346,
    SIP_WARNING = 347,
    SERVER_SIGNATURE = 348,
    SERVER_HEADER = 349,
    USER_AGENT_HEADER = 350,
    LOADMODULE = 351,
    MPATH = 352,
    MODPARAM = 353,
    MAXBUFFER = 354,
    CHROOT = 355,
    WDIR = 356,
    MHOMED = 357,
    POLL_METHOD = 358,
    TCP_ACCEPT_ALIASES = 359,
    TCP_WORKERS = 360,
    TCP_CONNECT_TIMEOUT = 361,
    TCP_CON_LIFETIME = 362,
    TCP_SOCKET_BACKLOG = 363,
    TCP_MAX_CONNECTIONS = 364,
    TCP_NO_NEW_CONN_BFLAG = 365,
    TCP_NO_NEW_CONN_RPLFLAG = 366,
    TCP_KEEPALIVE = 367,
    TCP_KEEPCOUNT = 368,
    TCP_KEEPIDLE = 369,
    TCP_KEEPINTERVAL = 370,
    TCP_MAX_MSG_TIME = 371,
    TCP_PARALLEL_READ_ON_WORKERS = 372,
    ADVERTISED_ADDRESS = 373,
    ADVERTISED_PORT = 374,
    DISABLE_CORE = 375,
    OPEN_FD_LIMIT = 376,
    MCAST_LOOPBACK = 377,
    MCAST_TTL = 378,
    TOS = 379,
    DISABLE_DNS_FAILOVER = 380,
    DISABLE_DNS_BLACKLIST = 381,
    DST_BLACKLIST = 382,
    DISABLE_STATELESS_FWD = 383,
    DB_VERSION_TABLE = 384,
    DB_DEFAULT_URL = 385,
    DB_MAX_ASYNC_CONNECTIONS = 386,
    DISABLE_503_TRANSLATION = 387,
    SYNC_TOKEN = 388,
    ASYNC_TOKEN = 389,
    LAUNCH_TOKEN = 390,
    AUTO_SCALING_PROFILE = 391,
    AUTO_SCALING_CYCLE = 392,
    TIMER_WORKERS = 393,
    EQUAL = 394,
    EQUAL_T = 395,
    GT = 396,
    LT = 397,
    GTE = 398,
    LTE = 399,
    DIFF = 400,
    MATCH = 401,
    NOTMATCH = 402,
    COLONEQ = 403,
    PLUSEQ = 404,
    MINUSEQ = 405,
    SLASHEQ = 406,
    MULTEQ = 407,
    MODULOEQ = 408,
    BANDEQ = 409,
    BOREQ = 410,
    BXOREQ = 411,
    OR = 412,
    AND = 413,
    BOR = 414,
    BAND = 415,
    BXOR = 416,
    BLSHIFT = 417,
    BRSHIFT = 418,
    PLUS = 419,
    MINUS = 420,
    SLASH = 421,
    MULT = 422,
    MODULO = 423,
    NOT = 424,
    BNOT = 425,
    RPAREN = 426,
    NUMBER = 427,
    ZERO = 428,
    ID = 429,
    STRING = 430,
    SCRIPTVAR = 431,
    IPV6ADDR = 432,
    IPV4ADDR = 433,
    IPNET = 434,
    COMMA = 435,
    SEMICOLON = 436,
    LPAREN = 437,
    LBRACE = 438,
    RBRACE = 439,
    LBRACK = 440,
    RBRACK = 441,
    AS = 442,
    USE_WORKERS = 443,
    USE_AUTO_SCALING_PROFILE = 444,
    MAX = 445,
    MIN = 446,
    DOT = 447,
    CR = 448,
    COLON = 449,
    ANY = 450,
    ANYCAST = 451,
    FRAG = 452,
    REUSE_PORT = 453,
    SCRIPTVARERR = 454,
    SCALE_UP_TO = 455,
    SCALE_DOWN_TO = 456,
    ON = 457,
    CYCLES = 458,
    CYCLES_WITHIN = 459,
    PERCENTAGE = 460
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 231 "cfg.y" /* yacc.c:355  */

	long intval;
	unsigned long uval;
	char* strval;
	struct expr* expr;
	struct action* action;
	struct net* ipnet;
	struct ip_addr* ipaddr;
	struct socket_id* sockid;
	struct listen_param* listen_param;
	struct _pv_spec *specval;
	struct multi_str* multistr;

#line 477 "cfg.tab.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_CFG_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 494 "cfg.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  232
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2349

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  206
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  88
/* YYNRULES -- Number of rules.  */
#define YYNRULES  517
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  986

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   460

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   499,   499,   502,   503,   504,   507,   508,   509,   509,
     510,   510,   511,   511,   512,   512,   513,   513,   514,   514,
     515,   515,   516,   516,   517,   517,   519,   522,   537,   546,
     561,   562,   565,   566,   580,   585,   595,   596,   599,   600,
     601,   605,   607,   609,   614,   620,   622,   626,   628,   630,
     632,   636,   639,   640,   643,   645,   647,   653,   656,   659,
     662,   665,   668,   671,   676,   677,   680,   681,   682,   682,
     687,   687,   694,   695,   697,   698,   701,   709,   718,   724,
     731,   737,   744,   750,   757,   763,   770,   776,   785,   786,
     787,   790,   791,   792,   795,   796,   799,   800,   801,   805,
     813,   821,   827,   835,   839,   851,   852,   853,   854,   855,
     856,   871,   873,   876,   877,   898,   899,   910,   911,   922,
     923,   932,   933,   939,   940,   946,   947,   967,   987,   995,
     996,  1004,  1005,  1012,  1013,  1019,  1020,  1023,  1024,  1025,
    1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,
    1036,  1037,  1038,  1039,  1040,  1041,  1042,  1043,  1044,  1045,
    1046,  1047,  1051,  1052,  1055,  1059,  1060,  1061,  1069,  1077,
    1085,  1093,  1101,  1109,  1117,  1125,  1133,  1141,  1144,  1145,
    1148,  1149,  1150,  1151,  1152,  1153,  1154,  1155,  1156,  1157,
    1158,  1159,  1160,  1161,  1171,  1172,  1186,  1187,  1188,  1189,
    1190,  1191,  1192,  1193,  1194,  1195,  1196,  1197,  1198,  1199,
    1200,  1201,  1211,  1221,  1222,  1227,  1228,  1231,  1235,  1236,
    1241,  1242,  1245,  1246,  1249,  1250,  1253,  1254,  1261,  1262,
    1269,  1271,  1274,  1275,  1278,  1279,  1282,  1285,  1292,  1293,
    1300,  1301,  1308,  1309,  1311,  1312,  1316,  1317,  1320,  1321,
    1323,  1324,  1326,  1328,  1330,  1331,  1332,  1333,  1335,  1336,
    1343,  1346,  1354,  1357,  1401,  1402,  1407,  1409,  1411,  1412,
    1418,  1420,  1434,  1436,  1439,  1440,  1443,  1444,  1451,  1452,
    1459,  1460,  1464,  1492,  1493,  1495,  1496,  1499,  1500,  1503,
    1504,  1514,  1524,  1526,  1528,  1529,  1531,  1532,  1534,  1537,
    1539,  1542,  1543,  1546,  1548,  1551,  1554,  1558,  1559,  1565,
    1571,  1577,  1581,  1582,  1585,  1601,  1617,  1618,  1621,  1627,
    1637,  1647,  1658,  1661,  1670,  1675,  1698,  1703,  1711,  1727,
    1730,  1736,  1739,  1747,  1753,  1756,  1762,  1765,  1773,  1776,
    1784,  1787,  1795,  1798,  1811,  1814,  1820,  1825,  1826,  1827,
    1828,  1829,  1830,  1833,  1834,  1837,  1838,  1839,  1840,  1842,
    1843,  1846,  1847,  1850,  1851,  1852,  1855,  1871,  1876,  1877,
    1878,  1880,  1885,  1888,  1891,  1894,  1897,  1903,  1904,  1905,
    1906,  1907,  1908,  1909,  1910,  1911,  1912,  1916,  1917,  1918,
    1919,  1920,  1921,  1924,  1927,  1930,  1933,  1936,  1939,  1942,
    1945,  1948,  1951,  1954,  1957,  1970,  1983,  2005,  2006,  2007,
    2008,  2009,  2012,  2013,  2014,  2017,  2018,  2019,  2022,  2023,
    2024,  2028,  2029,  2030,  2033,  2034,  2035,  2036,  2037,  2038,
    2039,  2040,  2043,  2044,  2045,  2046,  2047,  2048,  2049,  2050,
    2051,  2054,  2062,  2072,  2080,  2090,  2098,  2116,  2125,  2126,
    2128,  2129,  2132,  2138,  2144,  2150,  2158,  2161,  2164,  2169,
    2179,  2186,  2193,  2203,  2208,  2215,  2225,  2230,  2237,  2249,
    2254,  2259,  2264,  2269,  2279,  2289,  2299,  2311,  2329,  2360,
    2364,  2370,  2373,  2374,  2375,  2376,  2377,  2379,  2381,  2383,
    2385,  2387,  2388,  2391,  2397,  2398,  2400,  2406,  2407,  2409,
    2413,  2432,  2433,  2435,  2458,  2494,  2496,  2499,  2501,  2503,
    2505,  2507,  2509,  2511,  2518,  2525,  2532,  2539
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "DROP", "ASSERT", "EXIT", "RETURN",
  "LOG_TOK", "ERROR", "ROUTE", "ROUTE_FAILURE", "ROUTE_ONREPLY",
  "ROUTE_BRANCH", "ROUTE_ERROR", "ROUTE_LOCAL", "ROUTE_STARTUP",
  "ROUTE_TIMER", "ROUTE_EVENT", "IF", "ELSE", "SWITCH", "CASE", "DEFAULT",
  "BREAK", "WHILE", "FOR", "IN", "READONLY", "EXPIRE", "NULLV", "XDBG",
  "XLOG", "XLOG_BUF_SIZE", "XLOG_FORCE_COLOR", "XLOG_PRINT_LEVEL",
  "XLOG_LEVEL", "PV_PRINT_BUF_SIZE", "DEBUG_MODE", "ENABLE_ASSERTS",
  "ABORT_ON_ASSERT", "LOGLEVEL", "LOGPREFIX", "LOGSTDOUT", "LOGSTDERROR",
  "STDERROR_ENABLED", "SYSLOG_ENABLED", "LOG_EVENT_ENABLED",
  "STDERROR_LEVEL_FILTER", "SYSLOG_LEVEL_FILTER", "STDERROR_FORMAT",
  "SYSLOG_FORMAT", "LOG_JSON_BUF_SIZE", "LOG_MSG_BUF_SIZE", "LOGFACILITY",
  "SYSLOG_FACILITY", "LOGNAME", "SYSLOG_NAME", "AVP_ALIASES", "LISTEN",
  "SOCKET", "MEMGROUP", "ALIAS", "AUTO_ALIASES", "TAG", "DNS", "REV_DNS",
  "DNS_TRY_IPV6", "DNS_TRY_NAPTR", "DNS_RETR_TIME", "DNS_RETR_NO",
  "DNS_SERVERS_NO", "DNS_USE_SEARCH", "MAX_WHILE_LOOPS", "UDP_WORKERS",
  "CHECK_VIA", "SHM_HASH_SPLIT_PERCENTAGE", "SHM_SECONDARY_HASH_SIZE",
  "MEM_WARMING_ENABLED", "MEM_WARMING_PATTERN_FILE",
  "MEM_WARMING_PERCENTAGE", "RPM_MEM_FILE", "RPM_MEM_SIZE", "MEMLOG",
  "MEMDUMP", "SHM_MEMLOG_SIZE", "EXECMSGTHRESHOLD", "EXECDNSTHRESHOLD",
  "TCPTHRESHOLD", "EVENT_SHM_THRESHOLD", "EVENT_PKG_THRESHOLD",
  "QUERYBUFFERSIZE", "QUERYFLUSHTIME", "SIP_WARNING", "SERVER_SIGNATURE",
  "SERVER_HEADER", "USER_AGENT_HEADER", "LOADMODULE", "MPATH", "MODPARAM",
  "MAXBUFFER", "CHROOT", "WDIR", "MHOMED", "POLL_METHOD",
  "TCP_ACCEPT_ALIASES", "TCP_WORKERS", "TCP_CONNECT_TIMEOUT",
  "TCP_CON_LIFETIME", "TCP_SOCKET_BACKLOG", "TCP_MAX_CONNECTIONS",
  "TCP_NO_NEW_CONN_BFLAG", "TCP_NO_NEW_CONN_RPLFLAG", "TCP_KEEPALIVE",
  "TCP_KEEPCOUNT", "TCP_KEEPIDLE", "TCP_KEEPINTERVAL", "TCP_MAX_MSG_TIME",
  "TCP_PARALLEL_READ_ON_WORKERS", "ADVERTISED_ADDRESS", "ADVERTISED_PORT",
  "DISABLE_CORE", "OPEN_FD_LIMIT", "MCAST_LOOPBACK", "MCAST_TTL", "TOS",
  "DISABLE_DNS_FAILOVER", "DISABLE_DNS_BLACKLIST", "DST_BLACKLIST",
  "DISABLE_STATELESS_FWD", "DB_VERSION_TABLE", "DB_DEFAULT_URL",
  "DB_MAX_ASYNC_CONNECTIONS", "DISABLE_503_TRANSLATION", "SYNC_TOKEN",
  "ASYNC_TOKEN", "LAUNCH_TOKEN", "AUTO_SCALING_PROFILE",
  "AUTO_SCALING_CYCLE", "TIMER_WORKERS", "EQUAL", "EQUAL_T", "GT", "LT",
  "GTE", "LTE", "DIFF", "MATCH", "NOTMATCH", "COLONEQ", "PLUSEQ",
  "MINUSEQ", "SLASHEQ", "MULTEQ", "MODULOEQ", "BANDEQ", "BOREQ", "BXOREQ",
  "OR", "AND", "BOR", "BAND", "BXOR", "BLSHIFT", "BRSHIFT", "PLUS",
  "MINUS", "SLASH", "MULT", "MODULO", "NOT", "BNOT", "RPAREN", "NUMBER",
  "ZERO", "ID", "STRING", "SCRIPTVAR", "IPV6ADDR", "IPV4ADDR", "IPNET",
  "COMMA", "SEMICOLON", "LPAREN", "LBRACE", "RBRACE", "LBRACK", "RBRACK",
  "AS", "USE_WORKERS", "USE_AUTO_SCALING_PROFILE", "MAX", "MIN", "DOT",
  "CR", "COLON", "ANY", "ANYCAST", "FRAG", "REUSE_PORT", "SCRIPTVARERR",
  "SCALE_UP_TO", "SCALE_DOWN_TO", "ON", "CYCLES", "CYCLES_WITHIN",
  "PERCENTAGE", "$accept", "cfg", "statements", "statement", "$@1", "$@2",
  "$@3", "$@4", "$@5", "$@6", "$@7", "$@8", "$@9", "listen_id", "host_sep",
  "host", "proto", "port", "snumber", "phostport", "panyhostport",
  "alias_def", "id_lst", "listen_id_def", "socket_def_param",
  "socket_def_params", "socket_def", "$@10", "$@11", "any_proto",
  "multi_string", "blst_elem", "blst_def", "blst_flag", "blst_flags",
  "blst_elem_list", "auto_scale_profile_def", "assign_stm", "module_stm",
  "ip", "ipv4", "ipv6addr", "ipv6", "ipnet", "folded_string", "route_name",
  "route_name_var", "route_stm", "failure_route_stm", "onreply_route_stm",
  "branch_route_stm", "error_route_stm", "local_route_stm",
  "startup_route_stm", "timer_route_stm", "event_route_stm", "exp",
  "equalop", "compop", "matchop", "intop", "strop", "script_var",
  "exp_elem", "exp_cond", "assignop", "assignexp", "assign_cmd", "exp_stm",
  "brk_stm", "stm", "actions", "brk_actions", "action", "brk_action",
  "brk_if_cmd", "if_cmd", "while_cmd", "foreach_cmd", "switch_cmd",
  "switch_stm", "case_stms", "case_stm", "default_stm", "func_param",
  "route_param", "async_func", "cmd", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460
};
# endif

#define YYPACT_NINF -851

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-851)))

#define YYTABLE_NINF -457

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    2156,   -68,   -66,   -41,   -25,   -22,    -6,     9,    11,    41,
      47,    49,    60,   119,   276,   288,   293,   328,   358,   363,
     373,   380,   487,   488,   500,   502,   540,   542,   553,   554,
     555,   568,   570,   590,    56,    71,    73,   155,   390,   409,
     600,   603,   605,   616,   617,   635,   657,   667,   670,   672,
     677,   685,   697,   703,   711,   712,   714,   723,   724,   726,
     727,   729,   735,   740,    82,   744,    23,   746,   754,   755,
     757,   758,   761,   763,   765,   766,   785,   791,   792,   797,
     798,   801,   802,   803,   804,   813,   820,   830,   836,   848,
     849,   853,   861,   410,   411,   862,   867,   868,   870,   877,
     880,   885,   889,   890,  -851,   162,  1994,  -851,    94,   602,
     544,   631,   575,   614,   722,   772,   787,  -851,  -851,  -851,
     165,   193,   196,   346,   366,   381,   399,   417,   560,   104,
     418,   421,   425,   432,   433,   351,   356,   698,   741,   434,
     435,    26,   145,   109,   112,   170,   181,   779,   229,   441,
     442,   448,  -851,   854,  -851,   864,  -851,   865,  -851,   866,
    -851,   879,  -851,   881,   449,   450,   451,   452,   453,   457,
     114,   468,   123,   472,   369,   404,   408,   473,   474,   476,
     484,   486,   489,   490,   491,   495,   126,   131,  -851,  -851,
     133,  -851,   859,   503,   103,   125,   504,   158,   505,   508,
     512,   526,   534,   536,   166,   169,   538,   539,   543,   545,
     546,   550,   136,   551,   566,   573,   574,   576,   184,  -851,
     882,  -851,   888,   878,   893,   137,   143,   593,   594,   174,
     615,   894,  -851,   -68,  -851,     6,  -851,    19,  -851,    46,
    -851,    42,  -851,    30,  -851,    45,  -851,    63,  -851,    53,
    -851,    54,  -851,  -851,  -851,  -851,  -851,  -851,  -851,  -851,
     900,   901,  -851,  -851,  -851,  -851,  -851,  -851,  -851,  -851,
    -851,  -851,  -851,  -851,  -851,  -851,  -851,  -851,  -851,  -851,
    -851,  -851,  -851,  -851,  -851,  -851,  -851,  -851,  -851,  -851,
    -851,  -851,  -851,  -851,  -851,  -851,  -851,  -851,  -851,  -851,
    -851,  -851,  -851,  -851,  1039,  -851,   886,   759,   815,  -851,
    -851,  -851,   892,  -851,   897,  -851,  -851,  -851,   884,   898,
    -851,   -98,   902,  -851,   556,  -851,  -851,  -851,  -851,  -851,
    -851,  -851,  -851,  -851,  -851,  -851,  -851,  -851,  -851,  -851,
    -851,  -851,  -851,  -851,  -851,   917,  -851,  -851,  -851,  -851,
    -851,  -851,  -851,  -851,  -851,  -851,  -851,  -851,  -851,  -851,
    -851,  -851,  -851,  -851,  -851,  -851,  -851,  -851,  -851,  -851,
    -851,  -851,  -851,  -851,  -851,  -851,  -851,  -851,  -851,  -851,
    -851,  -851,  -851,  -851,  -851,  -851,  -851,  -851,  -851,  -851,
    -851,  -851,   875,  -851,  -851,  -851,  -851,  -851,  -851,  -851,
    -851,  -851,  -851,  -851,  -851,  -851,  -851,  -851,  -851,   921,
    -851,  -851,  -851,  -851,  -851,  -851,  -851,  -851,  -851,  -851,
    -851,  -851,  -851,  -851,  -851,  -851,  -851,  -851,  -851,  -851,
    -851,  -851,  -851,  -851,  -851,  -851,  -851,  -851,  -851,  -851,
    -851,  -851,  -851,  -851,  -851,  -851,  -851,  -851,  -851,  -851,
    -851,  -851,  -103,  -851,  -851,  -851,  -851,  -851,  -851,  -851,
    -851,  -851,  -851,   911,  -851,  -851,  -851,   928,  -851,  1817,
     673,  -851,   673,  -851,  1817,   673,  -851,   673,  -851,  1817,
    -851,  1817,  -851,  1817,  -851,   673,  -851,   673,  -851,  -851,
    -851,   583,   887,   887,   153,   891,   640,  -851,   192,   905,
     640,  -851,   913,   943,   945,   371,   939,  -851,   951,   954,
     947,   948,   949,   571,    67,    74,    83,   950,   952,   957,
     960,   963,   964,   968,   969,    84,  -851,  -851,  -851,  1611,
     974,   777,  -851,  -851,  -851,  -851,  -851,    91,  -851,  -851,
    -851,   955,   970,   851,   976,   977,   883,   914,   959,   981,
     979,   973,   982,   994,   640,   997,   996,  -851,  -851,  -851,
     887,  -851,  -851,  -851,  1009,  -851,  -851,   991,  -851,  -851,
    -851,  1006,  -851,  -851,  -851,  -851,  -851,  -115,   975,   986,
    -851,  1019,  1387,  1020,   -36,  -851,  -851,  -851,   152,  -851,
     160,  -851,   121,  1387,   -87,  1387,   -87,  1026,  1027,  1032,
    1032,  -851,    61,  1164,  1178,  -851,  -851,  -851,  -851,  -851,
    -851,  -851,  -851,  1573,  -851,  -851,  -851,  -851,  -851,  -851,
    1025,  1028,  -851,  1030,  1033,  -851,  -851,  -851,  1037,  1034,
     -56,     7,  -851,  1016,  -851,  -851,  -851,  -851,  -851,    29,
     858,   371,  -851,   930,  -851,   304,  -851,  -851,    75,  -851,
    -851,  1043,  -851,  1387,  1387,  1605,  1573,  -851,   -49,  1772,
    -851,  -851,  -851,  -851,  -851,  -851,  -851,  -851,  1047,  1049,
    1050,  1052,  1044,  1054,  1046,  1056,  -851,  -111,  -851,   -16,
    1057,   305,  1203,   -76,     1,   313,   440,    87,  1053,   -28,
    1061,  -851,  -851,   668,  -851,  -851,   -20,  -851,  -851,  1573,
    -851,  1573,  -851,  1105,  -851,  1705,  -851,  1817,  1817,  1817,
    1817,  1048,  1817,  -851,  -851,  -851,  -851,  -851,    39,  -851,
    -851,   511,  1064,   598,  -851,   304,  -851,  -851,  -851,  1074,
     245,  -851,  1018,  -851,  1088,  -851,   343,  -851,   990,  1382,
    1387,  1387,  1082,  -851,  -851,  -851,  -851,  -851,  -851,  -851,
    -851,   750,   -69,  -851,   560,   -18,  -851,  -851,  -851,  -851,
    1083,  -851,  1086,  -851,  -851,   662,  1634,  1079,  1419,   -87,
    -851,  -851,  -851,  -851,  -851,  1089,  -851,  -851,   110,   673,
    -851,   673,  -851,  -851,  -851,  -851,  -851,   734,  -851,  1631,
    1573,  1573,  1573,  1573,  1573,  1573,  1573,  1573,  1573,  1573,
    1038,  1096,  1174,  1235,  1080,  1280,  -851,  -851,  -851,  -851,
    -851,  1087,   300,   795,  -851,   -56,  -851,  1243,  -851,  -851,
    -851,  -851,  -851,  1098,  -851,  -851,  -851,  -851,  -851,  1100,
    1102,  -851,  -851,  -851,  -851,   315,  1679,  1255,  -851,  1254,
    1094,  1097,  -851,  1493,  1101,  -851,  -851,  -851,  -851,  -851,
    -851,    92,  1108,   601,   648,  1119,  -851,   323,   439,   507,
    -851,  -851,  -851,  -851,   626,   626,   626,   626,   626,  -851,
    -851,  -851,  -851,  -851,  -851,  -851,  -851,  -851,  1817,  -851,
     795,  -851,   -56,   569,  1120,  1121,  -851,  -851,  -851,  -851,
     806,  -851,  1311,  1634,   906,  1110,   416,  -851,  1387,  -851,
    -851,   665,  -851,  -851,  -851,  -851,  1419,  -851,  -851,  -851,
    -851,  -851,  1124,  -851,  1117,  1356,   618,  1126,  -851,   -56,
    -851,   388,  -851,  -851,  -851,  -851,  -851,  -851,  1107,  1109,
    -851,  1112,  -851,  -851,   385,  -851,  -851,  -851,  -851,  1128,
    1131,  -851,  -851,   -56,  -851,   641,  1106,  1141,  1711,  1711,
    1711,  1419,  -851,  -851,   649,  -851,  1146,  1150,  1122,   578,
     629,   696,  1305,  -851,  1151,  1154,  1125,  1156,  1419,  1159,
    -851,  1161,  1132,  -851,  -851,  1169,  1166,  1314,  1172,  1171,
    1319,  1142,  1175,  -851,  1143,  -851
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    26,     0,     0,     4,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     6,     7,   305,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   145,     0,   147,     0,   149,     0,   151,     0,
     153,     0,   155,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   307,   306,
       0,   311,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   287,
       0,   289,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     1,     5,     3,     0,     9,     0,    11,     0,
      13,     0,    15,     0,    17,     0,    19,     0,    21,     0,
      23,     0,    25,   254,   251,   255,   252,   256,   253,   258,
       0,     0,    38,   257,   250,   249,   111,   110,   107,   106,
     109,   108,   103,   105,   104,   113,   112,   115,   114,   117,
     116,   119,   118,   121,   120,   123,   122,   125,   124,   126,
     127,   129,   128,   131,   130,   133,   132,   135,   134,   137,
     136,   139,   138,   262,     0,    35,     0,    67,    66,   261,
     260,   259,     0,   266,    32,    28,   315,   314,     0,     0,
      47,    29,     0,    51,    52,   265,    27,   312,   316,   313,
     268,   267,   141,   140,   143,   142,   144,   146,   148,   150,
     152,   154,   157,   156,   162,   160,   166,   165,   168,   167,
     170,   169,   172,   171,   174,   173,   176,   175,   178,   177,
     180,   179,   182,   181,   186,   185,   184,   183,   188,   187,
     190,   189,   192,   191,   194,   193,   196,   195,   198,   197,
     200,   199,   202,   201,   244,   243,   246,   245,   248,   247,
     285,   284,     0,   159,   158,   205,   204,   203,   208,   207,
     206,   210,   209,   213,   211,   212,   215,   214,   218,   216,
     220,   219,   222,   221,   224,   223,   226,   225,   228,   227,
     230,   229,   232,   231,   238,   237,   240,   239,   242,   241,
     234,   233,   236,   235,   270,    32,   269,   272,   271,   274,
     273,   276,   275,   278,   277,   280,   279,   283,   281,   282,
     286,   288,    90,   292,   294,   293,   296,   295,   298,   297,
     300,   299,   302,     0,   301,   304,   303,   163,   329,     0,
       0,   331,     0,   334,     0,     0,   336,     0,   338,     0,
     340,     0,   342,     0,   344,     0,   346,     0,    39,    40,
      44,     0,     0,     0,     0,     0,     0,    31,     0,     0,
       0,    53,     0,     0,     0,     0,     0,   291,     0,     0,
     482,     0,   484,   491,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   366,   430,   367,     0,
       0,     0,   419,   425,   426,   427,   428,     0,   323,   322,
     324,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    45,    41,     0,     0,     0,     0,    57,    58,    59,
      64,    71,    69,   264,    74,   263,   317,    48,    34,    33,
     161,     0,   217,    93,    91,    92,    95,    90,     0,     0,
     164,     0,     0,     0,     0,   488,   486,   494,     0,   497,
       0,   501,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   506,     0,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,     0,   429,   420,   327,   418,   431,   424,
       0,     0,   332,     0,     0,   337,   339,   341,     0,     0,
       0,     0,    62,    54,    61,    60,    63,    65,    75,     0,
       0,     0,   290,     0,   318,     0,    89,    97,     0,   319,
      86,     0,   483,     0,     0,     0,     0,   370,     0,   371,
     352,   368,   409,   369,   408,   407,   485,   490,     0,     0,
       0,     0,     0,     0,     0,     0,   325,     0,   326,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   503,   458,   460,   463,   466,     0,   405,   406,     0,
     388,     0,   387,   389,   390,   404,   391,     0,     0,     0,
       0,     0,     0,    36,    37,    46,    43,    42,     0,    50,
      49,     0,     0,     0,    94,     0,    87,    72,    73,     0,
       0,    98,     0,    88,     0,   349,     0,   411,     0,     0,
       0,     0,     0,   353,   355,   356,   357,   358,   354,   359,
     360,   361,   362,   365,     0,     0,   489,   487,   495,   492,
       0,   498,     0,   502,   499,     0,     0,     0,     0,     0,
     507,   320,   508,   321,   509,     0,   510,   480,     0,     0,
     517,     0,   505,   461,   464,   467,   504,   462,   402,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    56,    55,   308,   310,
     309,     0,     0,     0,    84,     0,    96,     0,   350,   410,
     351,   348,   347,     0,   375,   376,   374,   373,   372,     0,
       0,   471,   469,   470,   472,     0,     0,   443,   415,     0,
       0,     0,   439,     0,     0,   445,   412,   434,   435,   436,
     437,     0,     0,     0,     0,     0,   477,     0,     0,     0,
     459,   465,   468,   403,   398,   397,   399,   400,   401,   392,
     393,   395,   394,   396,   328,   330,   333,   335,     0,   345,
       0,    85,     0,     0,     0,     0,   481,   493,   496,   500,
       0,   417,     0,     0,     0,     0,   449,   451,     0,   432,
     414,     0,   422,   438,   440,   433,     0,   511,   512,   479,
     478,   513,     0,   516,     0,     0,     0,     0,    80,     0,
      82,     0,   476,   473,   474,   475,   416,   444,     0,     0,
     447,     0,   450,   448,     0,   423,   413,   421,   446,     0,
       0,   343,    81,     0,    83,     0,   102,     0,   455,   453,
     457,     0,   514,   515,     0,    78,     0,     0,   101,     0,
       0,     0,   441,    79,     0,     0,     0,     0,     0,     0,
      76,     0,     0,   442,    77,     0,     0,     0,     0,     0,
       0,     0,     0,   100,     0,    99
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -851,  -851,  -851,  1245,  -851,  -851,  -851,  -851,  -851,  -851,
    -851,  -851,  -851,  -208,  -851,  -851,  -147,  -628,  -123,  -126,
    -851,  -851,  1029,  -851,  -851,  -458,  1206,  -851,  -851,   624,
     790,   634,   794,   715,  -851,  -851,  -851,  -851,  -851,  -146,
    -851,  1060,  -851,  -604,  -540,  -443,  -851,  -851,  -851,  -851,
    -851,  -851,  -851,  -851,  -851,  -851,  -534,  -851,  -851,  -851,
    -851,  -851,  -233,  -851,  -567,  -851,   676,  -572,  -851,  -850,
     475,  -465,  -424,  -498,   188,  -851,  -557,  -698,  -520,  -504,
    -851,  -851,   471,  -851,   604,  -851,   783,  -576
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   320,   499,   321,   306,   715,   702,   307,
     308,   324,   325,   634,   560,   561,   309,   493,   492,   729,
     565,   647,   507,   576,   577,   648,   464,   117,   118,   649,
     327,   328,   329,   650,   684,   541,   677,   236,   238,   240,
     242,   244,   246,   248,   250,   252,   658,   751,   752,   753,
     754,   755,   529,   660,   704,   613,   705,   530,   663,   845,
     837,   531,   901,   532,   846,   847,   533,   534,   535,   536,
     895,   896,   897,   933,   696,   835,   688,   537
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     263,   322,   326,   717,   436,   272,   665,   468,   716,   543,
     662,   720,   286,   288,   546,   661,   547,   665,   548,   665,
     471,   662,   323,   662,   191,   664,   661,   295,   661,   542,
     719,   478,   544,   617,   545,   562,   664,   706,   664,   726,
     806,   730,   549,   476,   550,   617,   480,   473,   617,   617,
     617,   363,   365,   367,   484,   486,   938,   152,   686,   679,
     764,   681,   690,   505,   482,   641,   326,   497,   587,   765,
     848,   119,   154,   120,   156,   589,   731,   665,   665,   506,
     706,   662,   662,   188,   591,   601,   661,   661,   777,   526,
     807,   506,   618,   904,   498,   770,   664,   664,   121,   771,
     723,   962,   637,   235,   395,   273,  -364,  -364,   740,   741,
     299,   855,   528,   301,   122,   354,   713,   123,   973,   735,
     736,   812,   675,   706,   358,   706,   398,   386,   260,   261,
    -364,   742,   388,   124,   390,   667,   262,   434,   454,   714,
     526,   740,   741,   780,   456,   848,   297,   825,   125,   676,
     126,   786,   781,   670,   563,   766,   158,   827,   526,   403,
     787,   673,   232,   528,   665,   665,   253,   418,   662,   662,
     420,   303,   772,   661,   661,   462,   773,   322,   326,   713,
     127,   528,   310,   664,   664,   447,   128,   884,   129,   469,
     738,   470,   851,   568,   255,   153,   844,   257,   323,   130,
     296,   713,   714,   848,   472,   192,   821,   822,   848,   883,
     155,   713,   157,   479,   706,   706,   706,   706,   706,   706,
     706,   706,   706,   706,   714,   260,   261,   477,   481,   474,
     313,   475,   691,   262,   714,   854,   692,   526,   485,   487,
     617,   693,   800,   801,   802,   803,   483,   805,   849,   588,
     848,   848,   848,   848,   917,   732,   590,   189,   131,   733,
     528,   848,   848,   848,   850,   592,   602,   851,   838,   778,
     848,   844,   619,   905,   260,   261,   916,   396,   397,   274,
     586,   856,   262,   552,   300,   692,   526,   302,   567,   355,
     693,   945,   552,   538,   159,   539,   540,   526,   359,   399,
     400,   387,   617,   617,   617,   617,   389,   617,   391,   528,
     435,   315,   455,   316,   317,   954,   260,   261,   457,   298,
     528,   318,   665,   849,   262,   851,   662,   671,   564,   844,
     851,   661,   404,   405,   844,   674,   858,   254,   859,   850,
     419,   664,   304,   421,   305,   326,   633,   259,   463,   659,
     326,   669,   285,   304,   326,   305,   448,   287,   449,   678,
     659,   680,   659,   682,   934,   256,   -30,   264,   258,   695,
     362,   892,   851,   851,   851,   851,   844,   844,   844,   844,
     703,   849,   266,   851,   851,   851,   849,   844,   844,   844,
     585,   160,   851,   573,   617,   838,   844,   850,   574,   575,
     268,   304,   850,   314,   315,   364,   316,   317,   326,   366,
     162,   219,   221,   915,   318,   132,   814,   617,   270,   275,
     659,   659,   277,   703,   319,   815,   279,   133,   849,   849,
     849,   849,   134,   281,   283,   291,   293,   894,   931,   849,
     849,   849,   330,   332,   850,   850,   850,   850,   849,   334,
     342,   344,   346,   348,   350,   850,   850,   850,   352,   657,
     785,   668,   740,   741,   850,   672,   703,   135,   703,   356,
     657,   881,   657,   360,   368,   370,   768,   372,   305,   694,
     882,   316,   317,   644,   774,   374,   889,   376,   771,   318,
     378,   380,   382,   775,   910,   890,   384,   136,   728,   727,
     740,   741,   137,   787,   393,   401,   406,   659,   659,   408,
     260,   261,   138,   410,   818,   260,   261,   722,   262,   139,
     260,   261,   828,   262,   959,   960,   961,   412,   262,   161,
     657,   657,   834,   260,   261,   414,   852,   416,   265,   422,
     424,   262,   740,   741,   426,   695,   428,   430,   163,   220,
     222,   432,   437,   267,   862,   239,   951,   703,   703,   703,
     703,   703,   703,   703,   703,   703,   703,   439,   260,   261,
     784,   269,   260,   261,   441,   443,   262,   445,   728,   935,
     262,   510,   511,   512,   513,   514,   515,   516,   243,   271,
     276,   946,   947,   278,   458,   460,   840,   280,   518,  -454,
    -454,   841,   519,   520,   282,   284,   292,   294,   521,   522,
     911,   776,   237,   331,   333,   773,   465,   657,   657,   912,
     335,   343,   345,   347,   349,   351,   140,   141,   245,   353,
     935,   826,   510,   511,   512,   513,   514,   515,   516,   142,
     357,   143,   833,   241,   361,   369,   371,   840,   373,   518,
    -452,  -452,   841,   519,   520,   694,   375,   925,   377,   521,
     522,   379,   381,   383,   861,   659,   935,   385,   510,   511,
     512,   513,   514,   515,   516,   394,   402,   407,   913,   144,
     409,   145,   808,   840,   411,   518,   771,   914,   841,   519,
     520,   831,   146,   147,   148,   521,   522,   935,   413,   510,
     511,   512,   513,   514,   515,   516,   415,   149,   417,   150,
     423,   425,   523,   524,   840,   427,   518,   429,   431,   841,
     519,   520,   433,   438,   260,   261,   521,   522,   304,   151,
     314,   315,   262,   316,   317,   260,   261,   247,   440,   164,
     918,   318,   165,   262,   166,   442,   444,   526,   446,   919,
     551,   319,   525,   584,   526,   167,   168,   435,   315,   842,
     316,   317,  -454,   523,   524,   459,   461,   924,   318,   810,
     528,   929,   907,   773,   169,   657,   771,   528,   615,   824,
     510,   511,   512,   513,   514,   515,   516,   466,   249,   942,
     795,   796,   797,   798,   799,   517,   170,   518,   943,   523,
     524,   519,   520,   525,   251,   526,   171,   521,   522,   172,
     842,   173,   955,  -452,   435,   315,   174,   316,   317,   908,
     963,   956,   -70,   773,   175,   318,   260,   261,   528,   964,
     523,   524,   260,   261,   262,   922,   176,   832,   526,   525,
     262,   526,   177,   783,   526,   538,   842,   539,   540,   936,
     178,   179,   615,   180,   510,   511,   512,   513,   514,   515,
     516,   528,   181,   182,   528,   183,   184,   528,   185,   517,
     525,   518,   526,   289,   186,   519,   520,   842,   -68,   187,
    -456,   521,   522,   190,   615,   193,   510,   511,   512,   513,
     514,   515,   516,   194,   195,   528,   196,   197,   260,   261,
     198,   517,   199,   518,   200,   201,   262,   519,   520,   860,
     526,   523,   524,   521,   522,   615,   290,   510,   511,   512,
     513,   514,   515,   516,   202,  -363,  -363,   316,   317,   644,
     203,   204,   517,   528,   518,   318,   205,   206,   519,   520,
     207,   208,   209,   210,   521,   522,   -70,   -70,   -70,  -363,
     553,   525,   211,   526,   312,   -70,   -70,   -70,   527,   212,
     615,   616,   510,   511,   512,   513,   514,   515,   516,   213,
     260,   261,   316,   317,   644,   214,   528,   517,   262,   518,
     318,   923,   526,   519,   520,   523,   524,   215,   216,   521,
     522,   615,   217,   510,   511,   512,   513,   514,   515,   516,
     218,   223,   -68,   -68,   -68,   528,   224,   225,   517,   226,
     518,   -68,   -68,   -68,   519,   520,   227,   523,   524,   228,
     521,   522,   260,   261,   229,   525,   336,   526,   230,   231,
     262,   902,   527,   721,   392,   622,   337,   338,   339,   615,
     490,   510,   511,   512,   513,   514,   515,   516,   523,   524,
     528,   340,   452,   341,   450,   503,   517,   525,   518,   526,
     451,   316,   519,   520,   527,   453,   467,   625,   521,   522,
     260,   261,   488,   489,   554,   555,   556,   566,   262,   569,
     491,   928,   528,   557,   558,   559,   494,   570,   525,   937,
     526,   -35,   496,   523,   524,   527,   500,   615,   626,   510,
     511,   512,   513,   514,   515,   516,   502,   316,   317,   644,
     504,   508,   725,   528,   517,   318,   518,   509,   571,   572,
     519,   520,   578,   579,   523,   524,   521,   522,   580,   581,
     582,   583,   593,   525,   594,   526,   902,   902,   902,   595,
     527,   620,   596,   627,   643,   597,   598,   937,   937,   937,
     599,   600,   316,   317,   644,   614,   621,   645,   528,   646,
     318,   628,   623,   624,   525,   629,   526,   630,   632,   635,
     636,   527,   523,   524,   819,   615,   631,   510,   511,   512,
     513,   514,   515,   516,   564,   639,   640,   643,   651,   528,
     652,   666,   517,   697,   518,   316,   317,   644,   519,   520,
     645,   683,   685,   318,   521,   522,   687,   698,   707,   711,
     718,   708,   525,   709,   526,   734,   710,   712,   756,   527,
     757,   758,   874,   759,   760,   761,   762,   763,   767,   769,
     523,   524,   782,   779,   804,   809,   615,   528,   510,   511,
     512,   513,   514,   515,   516,   743,   744,   745,   746,   747,
     748,   749,   750,   517,   813,   518,   817,   823,   829,   519,
     520,   830,   839,   878,   853,   521,   522,   880,   885,   886,
     525,   887,   526,   888,   893,   894,   898,   527,   899,   906,
     875,   615,   903,   510,   511,   512,   513,   514,   515,   516,
     909,   920,   940,   921,   930,   528,   939,   944,   517,   952,
     518,   948,   953,   949,   519,   520,   950,   957,   523,   524,
     521,   522,   615,   958,   510,   511,   512,   513,   514,   515,
     516,   965,   966,   967,   968,   970,   969,   971,   972,   517,
     974,   518,   739,   975,   976,   519,   520,   977,   978,   979,
     980,   521,   522,   981,   982,   983,   985,   984,   525,   811,
     526,   234,   311,   501,   638,   527,   724,   615,   876,   510,
     511,   512,   513,   514,   515,   516,   816,   932,   927,   523,
     524,   642,     0,   528,   517,   788,   518,   789,   495,     0,
     519,   520,   857,   689,     0,     0,   521,   522,     0,     0,
     510,   511,   512,   513,   514,   515,   516,     0,     0,     0,
       0,     0,     0,     0,     0,   517,     0,     0,     0,   525,
       0,   526,     0,     0,   523,   524,   527,   521,   522,   877,
       0,     0,   510,   511,   512,   513,   514,   515,   516,     0,
       0,     0,     0,     0,   528,     0,     0,   840,     0,   518,
       0,     0,   841,   519,   520,   523,   524,     0,     0,   521,
     522,     0,     0,     0,   525,     0,   526,     0,     0,     0,
       0,   527,     0,     0,   879,     0,   864,   865,   866,   867,
     868,   869,   870,   871,   872,   873,     0,     0,     0,   528,
       0,     0,     0,     0,     0,   525,     0,   526,     0,     0,
     523,   524,   527,     0,     0,   926,   510,   511,   512,   513,
     514,   515,   516,     0,     0,     0,     0,     0,     0,     0,
     528,   840,     0,   518,     0,     0,   841,   519,   520,     0,
       0,   523,   524,   521,   522,     0,     0,     0,     0,     0,
     525,     0,   526,     0,     0,     0,     0,   527,     0,     0,
     941,   790,   791,   792,   793,   794,   795,   796,   797,   798,
     799,   260,   261,   523,   524,   528,   653,     0,     0,   262,
       0,   525,     0,   526,     0,     0,     0,     0,   820,   654,
     655,     0,   656,     0,     0,     0,   510,   511,   512,   513,
     514,   515,   516,     0,     0,     0,   528,     0,     0,     0,
       0,     0,     0,   525,     0,   526,     0,     0,     0,     0,
     842,     0,   843,   521,   522,     0,     0,     0,   510,   511,
     512,   513,   514,   515,   516,     0,     0,     0,   528,     0,
       0,     0,     0,   517,     0,   518,     0,   523,   524,   519,
     520,     0,     0,     0,     0,   521,   522,   510,   511,   512,
     513,   514,   515,   516,     0,     0,     0,     0,     0,     0,
       0,     0,   517,     0,   518,     0,     0,     0,   519,   520,
       0,     0,     0,     0,   521,   522,     0,   525,     0,   526,
       0,     0,     0,     0,   842,     0,     0,   900,     0,     0,
       0,     0,   510,   511,   512,   513,   514,   515,   516,     0,
       0,     0,   528,     0,     0,     0,     0,   517,     0,   518,
       0,     0,     0,   519,   520,     0,     0,   523,   524,   521,
     522,     0,     0,     0,   510,   511,   512,   513,   514,   515,
     516,     0,     0,     0,     0,     0,     0,     0,     0,   840,
       0,   518,     0,     0,   841,   519,   520,   260,   261,   523,
     524,   521,   522,   699,     0,   262,     0,   525,   700,   526,
     603,     0,     0,     0,     0,   701,     0,     0,     0,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   523,   524,
       0,     0,   528,     0,     0,     0,     0,     0,     0,   525,
       0,   526,     0,     0,     0,     0,   527,     0,     0,   737,
     790,   791,   792,   793,   794,   795,   796,   797,   798,   799,
       0,     0,   863,     0,   528,     0,     0,     0,   525,     0,
     526,     0,     0,   523,   524,   527,     0,   836,     0,     0,
     510,   511,   512,   513,   514,   515,   516,     0,     0,     0,
       0,     0,     0,   528,     0,   517,     0,   518,     0,     0,
       0,   519,   520,     0,     0,   523,   524,   521,   522,     0,
       0,     0,     0,   525,     0,   526,     0,     0,     0,     0,
     527,     0,     0,   891,   790,   791,   792,   793,   794,   795,
     796,   797,   798,   799,     0,     0,     0,     0,   528,     0,
       0,     0,     0,     0,     0,   525,     0,   526,     0,     0,
       0,     0,   842,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     528,   603,   743,   744,   745,   746,   747,   748,   749,   750,
     604,   605,   606,   607,   608,   609,   610,   611,   612,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   523,   524,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   525,     0,   526,    -2,   233,     0,     0,   527,     0,
       0,     0,     0,    -8,   -10,   -12,   -14,   -16,   -18,   -20,
     -22,   -24,     0,     0,     0,     0,   528,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     2,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,     0,    27,    28,    29,    30,    31,     0,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,     0,     0,     0,
     101,   102,   103,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     1,     0,     0,
       0,     0,     0,     0,     0,    -8,   -10,   -12,   -14,   -16,
     -18,   -20,   -22,   -24,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   104,     2,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,     0,    27,    28,    29,    30,    31,     0,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,     0,
       0,     0,   101,   102,   103,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   104
};

static const yytype_int16 yycheck[] =
{
     123,   148,   148,   631,   212,   128,   582,     1,     1,   474,
     582,   639,   135,   136,   479,   582,   481,   593,   483,   595,
       1,   593,   148,   595,     1,   582,   593,     1,   595,   472,
       1,     1,   475,   531,   477,   493,   593,   613,   595,   643,
       1,   645,   485,     1,   487,   543,     1,     1,   546,   547,
     548,   174,   175,   176,     1,     1,   906,     1,   598,   593,
     171,   595,     1,   166,     1,   180,   212,   165,     1,   180,
     768,   139,     1,   139,     1,     1,     1,   653,   654,   194,
     656,   653,   654,     1,     1,     1,   653,   654,     1,   176,
     718,   194,     1,     1,   192,   171,   653,   654,   139,   175,
     640,   951,   560,     9,     1,     1,   175,   176,   157,   158,
       1,     1,   199,     1,   139,     1,   172,   139,   968,   653,
     654,   725,     1,   699,     1,   701,     1,     1,   164,   165,
     199,   180,     1,   139,     1,   171,   172,     1,     1,   195,
     176,   157,   158,   171,     1,   843,     1,   751,   139,   592,
     139,   171,   180,     1,     1,   171,     1,   175,   176,     1,
     180,     1,     0,   199,   740,   741,     1,     1,   740,   741,
       1,     1,   171,   740,   741,     1,   175,   324,   324,   172,
     139,   199,     1,   740,   741,     1,   139,   815,   139,   183,
     655,   185,   768,     1,     1,   139,   768,     1,   324,   139,
     174,   172,   195,   901,   185,   182,   740,   741,   906,   813,
     139,   172,   139,   183,   790,   791,   792,   793,   794,   795,
     796,   797,   798,   799,   195,   164,   165,   185,   183,   183,
       1,   185,   171,   172,   195,   775,   175,   176,   185,   185,
     738,   180,   707,   708,   709,   710,   183,   712,   768,   182,
     948,   949,   950,   951,   882,   180,   182,   175,   139,   184,
     199,   959,   960,   961,   768,   182,   182,   843,   766,   182,
     968,   843,   181,   181,   164,   165,   880,   174,   175,   175,
     513,   171,   172,   491,   175,   175,   176,   175,   496,   175,
     180,   919,   500,   172,   139,   174,   175,   176,   175,   174,
     175,   175,   800,   801,   802,   803,   175,   805,   175,   199,
     174,   175,   175,   177,   178,   943,   164,   165,   175,   174,
     199,   185,   898,   843,   172,   901,   898,   175,   175,   901,
     906,   898,   174,   175,   906,   175,   779,   172,   781,   843,
     174,   898,   172,   174,   174,   491,   554,     1,   174,   582,
     496,   584,     1,   172,   500,   174,   172,     1,   174,   592,
     593,   594,   595,   596,   898,   172,   174,     1,   172,   602,
       1,   836,   948,   949,   950,   951,   948,   949,   950,   951,
     613,   901,     1,   959,   960,   961,   906,   959,   960,   961,
     513,     1,   968,    22,   892,   893,   968,   901,    27,    28,
       1,   172,   906,   174,   175,     1,   177,   178,   554,     1,
       1,     1,     1,   878,   185,   139,   171,   915,     1,     1,
     653,   654,     1,   656,   195,   180,     1,   139,   948,   949,
     950,   951,   139,     1,     1,     1,     1,    21,    22,   959,
     960,   961,     1,     1,   948,   949,   950,   951,   968,     1,
       1,     1,     1,     1,     1,   959,   960,   961,     1,   582,
     693,   584,   157,   158,   968,   588,   699,   139,   701,     1,
     593,   171,   595,     1,     1,     1,   171,     1,   174,   602,
     180,   177,   178,   179,   171,     1,   171,     1,   175,   185,
       1,     1,     1,   180,   171,   180,     1,   139,   645,   195,
     157,   158,   139,   180,     1,     1,     1,   740,   741,     1,
     164,   165,   139,     1,   171,   164,   165,   640,   172,   139,
     164,   165,   755,   172,   948,   949,   950,     1,   172,   139,
     653,   654,   765,   164,   165,     1,   769,     1,   172,     1,
       1,   172,   157,   158,     1,   778,     1,     1,   139,   139,
     139,     1,     1,   172,   787,    11,   171,   790,   791,   792,
     793,   794,   795,   796,   797,   798,   799,     1,   164,   165,
     693,   172,   164,   165,     1,     1,   172,     1,   725,     1,
     172,     3,     4,     5,     6,     7,     8,     9,    13,   172,
     172,   203,   204,   172,     1,     1,    18,   172,    20,    21,
      22,    23,    24,    25,   172,   172,   172,   172,    30,    31,
     171,   171,    10,   172,   172,   175,     1,   740,   741,   180,
     172,   172,   172,   172,   172,   172,   139,   139,    14,   172,
       1,   754,     3,     4,     5,     6,     7,     8,     9,   139,
     172,   139,   765,    12,   172,   172,   172,    18,   172,    20,
      21,    22,    23,    24,    25,   778,   172,   890,   172,    30,
      31,   172,   172,   172,   787,   898,     1,   172,     3,     4,
       5,     6,     7,     8,     9,   172,   172,   172,   171,   139,
     172,   139,   171,    18,   172,    20,   175,   180,    23,    24,
      25,    29,   139,   139,   139,    30,    31,     1,   172,     3,
       4,     5,     6,     7,     8,     9,   172,   139,   172,   139,
     172,   172,   134,   135,    18,   172,    20,   172,   172,    23,
      24,    25,   172,   172,   164,   165,    30,    31,   172,   139,
     174,   175,   172,   177,   178,   164,   165,    15,   172,   139,
     171,   185,   139,   172,   139,   172,   172,   176,   172,   180,
     167,   195,   174,   182,   176,   139,   139,   174,   175,   181,
     177,   178,   184,   134,   135,   172,   172,   890,   185,   171,
     199,   894,   171,   175,   139,   898,   175,   199,     1,    29,
       3,     4,     5,     6,     7,     8,     9,   172,    16,   171,
     164,   165,   166,   167,   168,    18,   139,    20,   180,   134,
     135,    24,    25,   174,    17,   176,   139,    30,    31,   139,
     181,   139,   171,   184,   174,   175,   139,   177,   178,   171,
     171,   180,    63,   175,   139,   185,   164,   165,   199,   180,
     134,   135,   164,   165,   172,    29,   139,   175,   176,   174,
     172,   176,   139,   175,   176,   172,   181,   174,   175,   184,
     139,   139,     1,   139,     3,     4,     5,     6,     7,     8,
       9,   199,   139,   139,   199,   139,   139,   199,   139,    18,
     174,    20,   176,   175,   139,    24,    25,   181,    63,   139,
     184,    30,    31,   139,     1,   139,     3,     4,     5,     6,
       7,     8,     9,   139,   139,   199,   139,   139,   164,   165,
     139,    18,   139,    20,   139,   139,   172,    24,    25,   175,
     176,   134,   135,    30,    31,     1,   175,     3,     4,     5,
       6,     7,     8,     9,   139,   175,   176,   177,   178,   179,
     139,   139,    18,   199,    20,   185,   139,   139,    24,    25,
     139,   139,   139,   139,    30,    31,   187,   188,   189,   199,
      63,   174,   139,   176,   175,   196,   197,   198,   181,   139,
       1,   184,     3,     4,     5,     6,     7,     8,     9,   139,
     164,   165,   177,   178,   179,   139,   199,    18,   172,    20,
     185,   175,   176,    24,    25,   134,   135,   139,   139,    30,
      31,     1,   139,     3,     4,     5,     6,     7,     8,     9,
     139,   139,   187,   188,   189,   199,   139,   139,    18,   139,
      20,   196,   197,   198,    24,    25,   139,   134,   135,   139,
      30,    31,   164,   165,   139,   174,   172,   176,   139,   139,
     172,   843,   181,   175,   175,   184,   172,   172,   172,     1,
       1,     3,     4,     5,     6,     7,     8,     9,   134,   135,
     199,   172,   174,   172,   172,   180,    18,   174,    20,   176,
     172,   177,    24,    25,   181,   172,   172,   184,    30,    31,
     164,   165,   172,   172,   187,   188,   189,   186,   172,   174,
     194,   175,   199,   196,   197,   198,   194,   174,   174,   901,
     176,   194,   194,   134,   135,   181,   194,     1,   184,     3,
       4,     5,     6,     7,     8,     9,   189,   177,   178,   179,
     189,   200,   182,   199,    18,   185,    20,   189,   175,   174,
      24,    25,   183,   172,   134,   135,    30,    31,   174,   182,
     182,   182,   182,   174,   182,   176,   948,   949,   950,   182,
     181,   186,   182,   184,   169,   182,   182,   959,   960,   961,
     182,   182,   177,   178,   179,   181,   186,   182,   199,   184,
     185,   180,   186,   186,   174,   186,   176,   194,   174,   172,
     174,   181,   134,   135,   184,     1,   194,     3,     4,     5,
       6,     7,     8,     9,   175,   194,   180,   169,   202,   199,
     171,   171,    18,    29,    20,   177,   178,   179,    24,    25,
     182,   175,   175,   185,    30,    31,   174,    29,   183,   172,
     194,   183,   174,   183,   176,   172,   183,   183,   171,   181,
     171,   171,   184,   171,   180,   171,   180,   171,   171,    26,
     134,   135,   171,   180,   186,   171,     1,   199,     3,     4,
       5,     6,     7,     8,     9,   140,   141,   142,   143,   144,
     145,   146,   147,    18,   180,    20,   168,   175,   175,    24,
      25,   175,   183,   183,   175,    30,    31,   180,    25,   171,
     174,   171,   176,   171,    19,    21,   182,   181,   181,   171,
     184,     1,   181,     3,     4,     5,     6,     7,     8,     9,
     171,   171,   175,   172,   184,   199,   172,   171,    18,   171,
      20,   194,   171,   194,    24,    25,   194,   201,   134,   135,
      30,    31,     1,   172,     3,     4,     5,     6,     7,     8,
       9,   175,   172,   201,    19,   171,   175,   202,   172,    18,
     171,    20,   656,   172,   202,    24,    25,   168,   172,    25,
     168,    30,    31,   172,    25,   203,   203,   172,   174,   725,
     176,   106,   146,   324,   564,   181,   641,     1,   184,     3,
       4,     5,     6,     7,     8,     9,   732,   896,   893,   134,
     135,   577,    -1,   199,    18,   699,    20,   701,   318,    -1,
      24,    25,   778,   600,    -1,    -1,    30,    31,    -1,    -1,
       3,     4,     5,     6,     7,     8,     9,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    -1,    -1,    -1,   174,
      -1,   176,    -1,    -1,   134,   135,   181,    30,    31,   184,
      -1,    -1,     3,     4,     5,     6,     7,     8,     9,    -1,
      -1,    -1,    -1,    -1,   199,    -1,    -1,    18,    -1,    20,
      -1,    -1,    23,    24,    25,   134,   135,    -1,    -1,    30,
      31,    -1,    -1,    -1,   174,    -1,   176,    -1,    -1,    -1,
      -1,   181,    -1,    -1,   184,    -1,   790,   791,   792,   793,
     794,   795,   796,   797,   798,   799,    -1,    -1,    -1,   199,
      -1,    -1,    -1,    -1,    -1,   174,    -1,   176,    -1,    -1,
     134,   135,   181,    -1,    -1,   184,     3,     4,     5,     6,
       7,     8,     9,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     199,    18,    -1,    20,    -1,    -1,    23,    24,    25,    -1,
      -1,   134,   135,    30,    31,    -1,    -1,    -1,    -1,    -1,
     174,    -1,   176,    -1,    -1,    -1,    -1,   181,    -1,    -1,
     184,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   164,   165,   134,   135,   199,   169,    -1,    -1,   172,
      -1,   174,    -1,   176,    -1,    -1,    -1,    -1,   186,   182,
     183,    -1,   185,    -1,    -1,    -1,     3,     4,     5,     6,
       7,     8,     9,    -1,    -1,    -1,   199,    -1,    -1,    -1,
      -1,    -1,    -1,   174,    -1,   176,    -1,    -1,    -1,    -1,
     181,    -1,   183,    30,    31,    -1,    -1,    -1,     3,     4,
       5,     6,     7,     8,     9,    -1,    -1,    -1,   199,    -1,
      -1,    -1,    -1,    18,    -1,    20,    -1,   134,   135,    24,
      25,    -1,    -1,    -1,    -1,    30,    31,     3,     4,     5,
       6,     7,     8,     9,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    -1,    20,    -1,    -1,    -1,    24,    25,
      -1,    -1,    -1,    -1,    30,    31,    -1,   174,    -1,   176,
      -1,    -1,    -1,    -1,   181,    -1,    -1,   184,    -1,    -1,
      -1,    -1,     3,     4,     5,     6,     7,     8,     9,    -1,
      -1,    -1,   199,    -1,    -1,    -1,    -1,    18,    -1,    20,
      -1,    -1,    -1,    24,    25,    -1,    -1,   134,   135,    30,
      31,    -1,    -1,    -1,     3,     4,     5,     6,     7,     8,
       9,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,
      -1,    20,    -1,    -1,    23,    24,    25,   164,   165,   134,
     135,    30,    31,   170,    -1,   172,    -1,   174,   175,   176,
     139,    -1,    -1,    -1,    -1,   182,    -1,    -1,    -1,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   134,   135,
      -1,    -1,   199,    -1,    -1,    -1,    -1,    -1,    -1,   174,
      -1,   176,    -1,    -1,    -1,    -1,   181,    -1,    -1,   184,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
      -1,    -1,   171,    -1,   199,    -1,    -1,    -1,   174,    -1,
     176,    -1,    -1,   134,   135,   181,    -1,   183,    -1,    -1,
       3,     4,     5,     6,     7,     8,     9,    -1,    -1,    -1,
      -1,    -1,    -1,   199,    -1,    18,    -1,    20,    -1,    -1,
      -1,    24,    25,    -1,    -1,   134,   135,    30,    31,    -1,
      -1,    -1,    -1,   174,    -1,   176,    -1,    -1,    -1,    -1,
     181,    -1,    -1,   184,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,    -1,    -1,    -1,    -1,   199,    -1,
      -1,    -1,    -1,    -1,    -1,   174,    -1,   176,    -1,    -1,
      -1,    -1,   181,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     199,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   134,   135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   174,    -1,   176,     0,     1,    -1,    -1,   181,    -1,
      -1,    -1,    -1,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    -1,    -1,    -1,    -1,   199,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    -1,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,    -1,    -1,    -1,
     136,   137,   138,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   193,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    -1,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,    -1,
      -1,    -1,   136,   137,   138,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   193
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     1,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    58,    59,    60,
      61,    62,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   136,   137,   138,   193,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   243,   244,   139,
     139,   139,   139,   139,   139,   139,   139,   139,   139,   139,
     139,   139,   139,   139,   139,   139,   139,   139,   139,   139,
     139,   139,   139,   139,   139,   139,   139,   139,   139,   139,
     139,   139,     1,   139,     1,   139,     1,   139,     1,   139,
       1,   139,     1,   139,   139,   139,   139,   139,   139,   139,
     139,   139,   139,   139,   139,   139,   139,   139,   139,   139,
     139,   139,   139,   139,   139,   139,   139,   139,     1,   175,
     139,     1,   182,   139,   139,   139,   139,   139,   139,   139,
     139,   139,   139,   139,   139,   139,   139,   139,   139,   139,
     139,   139,   139,   139,   139,   139,   139,   139,   139,     1,
     139,     1,   139,   139,   139,   139,   139,   139,   139,   139,
     139,   139,     0,     1,   209,     9,   253,    10,   254,    11,
     255,    12,   256,    13,   257,    14,   258,    15,   259,    16,
     260,    17,   261,     1,   172,     1,   172,     1,   172,     1,
     164,   165,   172,   224,     1,   172,     1,   172,     1,   172,
       1,   172,   224,     1,   175,     1,   172,     1,   172,     1,
     172,     1,   172,     1,   172,     1,   224,     1,   224,   175,
     175,     1,   172,     1,   172,     1,   174,     1,   174,     1,
     175,     1,   175,     1,   172,   174,   222,   225,   226,   232,
       1,   232,   175,     1,   174,   175,   177,   178,   185,   195,
     219,   221,   222,   225,   227,   228,   245,   246,   247,   248,
       1,   172,     1,   172,     1,   172,   172,   172,   172,   172,
     172,   172,     1,   172,     1,   172,     1,   172,     1,   172,
       1,   172,     1,   172,     1,   175,     1,   172,     1,   175,
       1,   172,     1,   224,     1,   224,     1,   224,     1,   172,
       1,   172,     1,   172,     1,   172,     1,   172,     1,   172,
       1,   172,     1,   172,     1,   172,     1,   175,     1,   175,
       1,   175,   175,     1,   172,     1,   174,   175,     1,   174,
     175,     1,   172,     1,   174,   175,     1,   172,     1,   172,
       1,   172,     1,   172,     1,   172,     1,   172,     1,   174,
       1,   174,     1,   172,     1,   172,     1,   172,     1,   172,
       1,   172,     1,   172,     1,   174,   219,     1,   172,     1,
     172,     1,   172,     1,   172,     1,   172,     1,   172,   174,
     172,   172,   174,   172,     1,   175,     1,   175,     1,   172,
       1,   172,     1,   174,   242,     1,   172,   172,     1,   183,
     185,     1,   185,     1,   183,   185,     1,   185,     1,   183,
       1,   183,     1,   183,     1,   185,     1,   185,   172,   172,
       1,   194,   234,   233,   194,   247,   194,   165,   192,   220,
     194,   228,   189,   180,   189,   166,   194,   238,   200,   189,
       3,     4,     5,     6,     7,     8,     9,    18,    20,    24,
      25,    30,    31,   134,   135,   174,   176,   181,   199,   268,
     273,   277,   279,   282,   283,   284,   285,   293,   172,   174,
     175,   251,   251,   277,   251,   251,   277,   277,   277,   251,
     251,   167,   219,    63,   187,   188,   189,   196,   197,   198,
     230,   231,   231,     1,   175,   236,   186,   219,     1,   174,
     174,   175,   174,    22,    27,    28,   239,   240,   183,   172,
     174,   182,   182,   182,   182,   224,   268,     1,   182,     1,
     182,     1,   182,   182,   182,   182,   182,   182,   182,   182,
     182,     1,   182,   139,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   271,   181,     1,   184,   279,     1,   181,
     186,   186,   184,   186,   186,   184,   184,   184,   180,   186,
     194,   194,   174,   219,   229,   172,   174,   231,   236,   194,
     180,   180,   238,   169,   179,   182,   184,   237,   241,   245,
     249,   202,   171,   169,   182,   183,   185,   224,   262,   268,
     269,   270,   273,   274,   282,   293,   171,   171,   224,   268,
       1,   175,   224,     1,   175,     1,   251,   252,   268,   262,
     268,   262,   268,   175,   250,   175,   250,   174,   292,   292,
       1,   171,   175,   180,   224,   268,   290,    29,    29,   170,
     175,   182,   224,   268,   270,   272,   293,   183,   183,   183,
     183,   172,   183,   172,   195,   223,     1,   223,   194,     1,
     223,   175,   224,   250,   239,   182,   249,   195,   222,   235,
     249,     1,   180,   184,   172,   262,   262,   184,   277,   272,
     157,   158,   180,   140,   141,   142,   143,   144,   145,   146,
     147,   263,   264,   265,   266,   267,   171,   171,   171,   171,
     180,   171,   180,   171,   171,   180,   171,   171,   171,    26,
     171,   175,   171,   175,   171,   180,   171,     1,   182,   180,
     171,   180,   171,   175,   224,   268,   171,   180,   272,   272,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     277,   277,   277,   277,   186,   277,     1,   223,   171,   171,
     171,   235,   249,   180,   171,   180,   237,   168,   171,   184,
     186,   262,   262,   175,    29,   249,   224,   175,   268,   175,
     175,    29,   175,   224,   268,   291,   183,   276,   279,   183,
      18,    23,   181,   183,   273,   275,   280,   281,   283,   284,
     285,   293,   268,   175,   250,     1,   171,   290,   251,   251,
     175,   224,   268,   171,   272,   272,   272,   272,   272,   272,
     272,   272,   272,   272,   184,   184,   184,   184,   183,   184,
     180,   171,   180,   249,   223,    25,   171,   171,   171,   171,
     180,   184,   277,    19,    21,   286,   287,   288,   182,   181,
     184,   278,   280,   181,     1,   181,   171,   171,   171,   171,
     171,   171,   180,   171,   180,   277,   249,   223,   171,   180,
     171,   172,    29,   175,   224,   268,   184,   276,   175,   224,
     184,    22,   288,   289,   262,     1,   184,   280,   275,   172,
     175,   184,   171,   180,   171,   223,   203,   204,   194,   194,
     194,   171,   171,   171,   223,   171,   180,   201,   172,   278,
     278,   278,   275,   171,   180,   175,   172,   201,    19,   175,
     171,   202,   172,   275,   171,   172,   202,   168,   172,    25,
     168,   172,    25,   203,   172,   203
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   206,   207,   208,   208,   208,   209,   209,   210,   209,
     211,   209,   212,   209,   213,   209,   214,   209,   215,   209,
     216,   209,   217,   209,   218,   209,   209,   219,   219,   219,
     220,   220,   221,   221,   221,   222,   223,   223,   224,   224,
     224,   225,   225,   225,   225,   226,   226,   227,   227,   227,
     227,   227,   228,   228,   229,   229,   229,   230,   230,   230,
     230,   230,   230,   230,   231,   231,   232,   232,   233,   232,
     234,   232,   235,   235,   236,   236,   237,   237,   237,   237,
     237,   237,   237,   237,   237,   237,   237,   237,   238,   238,
     238,   239,   239,   239,   240,   240,   241,   241,   241,   242,
     242,   242,   242,   243,   243,   243,   243,   243,   243,   243,
     243,   243,   243,   243,   243,   243,   243,   243,   243,   243,
     243,   243,   243,   243,   243,   243,   243,   243,   243,   243,
     243,   243,   243,   243,   243,   243,   243,   243,   243,   243,
     243,   243,   243,   243,   243,   243,   243,   243,   243,   243,
     243,   243,   243,   243,   243,   243,   243,   243,   243,   243,
     243,   243,   243,   243,   243,   243,   243,   243,   243,   243,
     243,   243,   243,   243,   243,   243,   243,   243,   243,   243,
     243,   243,   243,   243,   243,   243,   243,   243,   243,   243,
     243,   243,   243,   243,   243,   243,   243,   243,   243,   243,
     243,   243,   243,   243,   243,   243,   243,   243,   243,   243,
     243,   243,   243,   243,   243,   243,   243,   243,   243,   243,
     243,   243,   243,   243,   243,   243,   243,   243,   243,   243,
     243,   243,   243,   243,   243,   243,   243,   243,   243,   243,
     243,   243,   243,   243,   243,   243,   243,   243,   243,   243,
     243,   243,   243,   243,   243,   243,   243,   243,   243,   243,
     243,   243,   243,   243,   243,   243,   243,   243,   243,   243,
     243,   243,   243,   243,   243,   243,   243,   243,   243,   243,
     243,   243,   243,   243,   243,   243,   243,   243,   243,   243,
     243,   243,   243,   243,   243,   243,   243,   243,   243,   243,
     243,   243,   243,   243,   243,   243,   244,   244,   244,   244,
     244,   244,   245,   245,   246,   247,   248,   248,   249,   249,
     250,   250,   251,   251,   251,   252,   252,   253,   253,   253,
     254,   254,   255,   255,   255,   256,   256,   257,   257,   258,
     258,   259,   259,   260,   260,   261,   261,   262,   262,   262,
     262,   262,   262,   263,   263,   264,   264,   264,   264,   265,
     265,   266,   266,   267,   267,   267,   268,   268,   269,   269,
     269,   269,   270,   270,   270,   270,   270,   271,   271,   271,
     271,   271,   271,   271,   271,   271,   271,   272,   272,   272,
     272,   272,   272,   272,   272,   272,   272,   272,   272,   272,
     272,   272,   272,   272,   273,   273,   273,   274,   274,   274,
     274,   274,   275,   275,   275,   276,   276,   276,   277,   277,
     277,   278,   278,   278,   279,   279,   279,   279,   279,   279,
     279,   279,   280,   280,   280,   280,   280,   280,   280,   280,
     280,   281,   281,   282,   282,   283,   284,   285,   286,   286,
     287,   287,   288,   288,   288,   288,   289,   289,   290,   290,
     290,   290,   290,   290,   290,   290,   290,   290,   290,   291,
     291,   291,   291,   291,   291,   291,   291,   292,   292,   292,
     292,   293,   293,   293,   293,   293,   293,   293,   293,   293,
     293,   293,   293,   293,   293,   293,   293,   293,   293,   293,
     293,   293,   293,   293,   293,   293,   293,   293,   293,   293,
     293,   293,   293,   293,   293,   293,   293,   293
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     1,     2,     1,     1,     0,     2,
       0,     2,     0,     2,     0,     2,     0,     2,     0,     2,
       0,     2,     0,     2,     0,     2,     1,     1,     1,     1,
       1,     1,     1,     3,     3,     1,     1,     1,     1,     2,
       2,     3,     5,     5,     2,     3,     5,     1,     3,     5,
       5,     1,     1,     2,     1,     3,     3,     1,     1,     1,
       2,     2,     2,     2,     1,     2,     1,     1,     0,     3,
       0,     3,     1,     1,     1,     2,     9,    10,     7,     8,
       5,     6,     5,     6,     3,     4,     1,     2,     4,     3,
       0,     1,     1,     1,     3,     1,     3,     1,     2,    18,
      17,    10,     9,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     3,     3,     3,
       3,     5,     3,     3,     5,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     5,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     5,     5,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     2,     3,     2,
       6,     4,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     2,     2,     8,     8,
       8,     2,     1,     1,     1,     1,     1,     3,     1,     1,
       2,     2,     1,     1,     1,     1,     1,     4,     7,     2,
       7,     2,     4,     7,     2,     7,     2,     4,     2,     4,
       2,     4,     2,     9,     2,     7,     2,     3,     3,     2,
       3,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     3,     3,     3,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     2,     3,     3,     3,     3,     1,     1,     1,
       3,     2,     1,     3,     2,     1,     3,     2,     2,     1,
       2,     2,     1,     2,     2,     1,     1,     1,     1,     2,
       1,     2,     2,     2,     1,     1,     1,     1,     2,     1,
       2,     5,     7,     5,     7,     5,     7,     7,     2,     1,
       2,     1,     4,     3,     4,     3,     3,     2,     1,     3,
       1,     2,     2,     1,     2,     3,     1,     2,     3,     1,
       1,     1,     1,     3,     3,     3,     3,     3,     4,     4,
       2,     6,     1,     3,     1,     3,     2,     4,     2,     4,
       3,     1,     4,     6,     2,     4,     6,     2,     4,     4,
       6,     2,     4,     3,     4,     4,     2,     4,     4,     4,
       4,     6,     6,     6,     8,     8,     6,     4
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 3:
#line 502 "cfg.y" /* yacc.c:1646  */
    {}
#line 2589 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 4:
#line 503 "cfg.y" /* yacc.c:1646  */
    {}
#line 2595 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 5:
#line 504 "cfg.y" /* yacc.c:1646  */
    { yyerror(""); YYABORT;}
#line 2601 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 8:
#line 509 "cfg.y" /* yacc.c:1646  */
    {rt=REQUEST_ROUTE;}
#line 2607 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 10:
#line 510 "cfg.y" /* yacc.c:1646  */
    {rt=FAILURE_ROUTE;}
#line 2613 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 12:
#line 511 "cfg.y" /* yacc.c:1646  */
    {rt=ONREPLY_ROUTE;}
#line 2619 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 14:
#line 512 "cfg.y" /* yacc.c:1646  */
    {rt=BRANCH_ROUTE;}
#line 2625 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 16:
#line 513 "cfg.y" /* yacc.c:1646  */
    {rt=ERROR_ROUTE;}
#line 2631 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 18:
#line 514 "cfg.y" /* yacc.c:1646  */
    {rt=LOCAL_ROUTE;}
#line 2637 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 20:
#line 515 "cfg.y" /* yacc.c:1646  */
    {rt=STARTUP_ROUTE;}
#line 2643 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 22:
#line 516 "cfg.y" /* yacc.c:1646  */
    {rt=TIMER_ROUTE;}
#line 2649 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 24:
#line 517 "cfg.y" /* yacc.c:1646  */
    {rt=EVENT_ROUTE;}
#line 2655 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 27:
#line 522 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							tmp=ip_addr2a((yyvsp[0].ipaddr));
							if(tmp==0){
								LM_CRIT("cfg. parser: bad ip address.\n");
								(yyval.strval)=0;
							}else{
								(yyval.strval)=pkg_malloc(strlen(tmp)+1);
								if ((yyval.strval)==0){
									LM_CRIT("cfg. parser: out of memory.\n");
									YYABORT;
								}else{
									memcpy((yyval.strval), tmp, strlen(tmp)+1);
								}
							}
						}
#line 2675 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 28:
#line 537 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							(yyval.strval)=pkg_malloc(strlen((yyvsp[0].strval))+1);
							if ((yyval.strval)==0){
									LM_CRIT("cfg. parser: out of memory.\n");
									YYABORT;
							}else{
									memcpy((yyval.strval), (yyvsp[0].strval), strlen((yyvsp[0].strval))+1);
							}
						}
#line 2689 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 29:
#line 546 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							if ((yyvsp[0].strval)==0) {
								(yyval.strval) = 0;
							} else {
								(yyval.strval)=pkg_malloc(strlen((yyvsp[0].strval))+1);
								if ((yyval.strval)==0){
									LM_CRIT("cfg. parser: out of memory.\n");
									YYABORT;
								}else{
									memcpy((yyval.strval), (yyvsp[0].strval), strlen((yyvsp[0].strval))+1);
								}
							}
						}
#line 2707 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 30:
#line 561 "cfg.y" /* yacc.c:1646  */
    {(yyval.strval)=".";}
#line 2713 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 31:
#line 562 "cfg.y" /* yacc.c:1646  */
    {(yyval.strval)="-"; }
#line 2719 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 32:
#line 565 "cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=(yyvsp[0].strval); }
#line 2725 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 33:
#line 566 "cfg.y" /* yacc.c:1646  */
    { IFOR();
						(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))+1);
						if ((yyval.strval)==0){
							LM_CRIT("cfg. parser: memory allocation"
										" failure while parsing host\n");
							YYABORT;
						}else{
							memcpy((yyval.strval), (yyvsp[-2].strval), strlen((yyvsp[-2].strval)));
							(yyval.strval)[strlen((yyvsp[-2].strval))]=*(yyvsp[-1].strval);
							memcpy((yyval.strval)+strlen((yyvsp[-2].strval))+1, (yyvsp[0].strval), strlen((yyvsp[0].strval)));
							(yyval.strval)[strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))]=0;
						}
						pkg_free((yyvsp[-2].strval)); pkg_free((yyvsp[0].strval));
					}
#line 2744 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 34:
#line 580 "cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=0; pkg_free((yyvsp[-2].strval));
					yyerror("invalid hostname (use quotes if hostname "
						"has config keywords)"); }
#line 2752 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 35:
#line 585 "cfg.y" /* yacc.c:1646  */
    { IFOR();
		if (parse_proto((unsigned char *)(yyvsp[0].strval), strlen((yyvsp[0].strval)), &i_tmp) < 0) {
			yyerrorf("cannot handle protocol <%s>\n", (yyvsp[0].strval));
			YYABORT;
		}
		pkg_free((yyvsp[0].strval));
		(yyval.intval) = i_tmp;
	 }
#line 2765 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 36:
#line 595 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=(yyvsp[0].intval); }
#line 2771 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 37:
#line 596 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=0; }
#line 2777 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 38:
#line 599 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=(yyvsp[0].intval); }
#line 2783 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 39:
#line 600 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=(yyvsp[0].intval); }
#line 2789 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 40:
#line 601 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=-(yyvsp[0].intval); }
#line 2795 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 41:
#line 605 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				(yyval.sockid)=mk_listen_id((yyvsp[0].strval), (yyvsp[-2].intval), 0); }
#line 2802 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 42:
#line 607 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				(yyval.sockid)=mk_listen_id((yyvsp[-2].strval), (yyvsp[-4].intval), (yyvsp[0].intval));}
#line 2809 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 43:
#line 609 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.sockid)=0;
				yyerror("port number expected");
				YYABORT;
				}
#line 2819 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 44:
#line 614 "cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=0;
				yyerror("protocol expected");
				YYABORT;
			}
#line 2828 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 45:
#line 620 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				(yyval.sockid)=mk_listen_id(0, (yyvsp[-2].intval), 0); }
#line 2835 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 46:
#line 622 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				(yyval.sockid)=mk_listen_id(0, (yyvsp[-4].intval), (yyvsp[0].intval)); }
#line 2842 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 47:
#line 626 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				(yyval.sockid)=mk_listen_id((yyvsp[0].strval), PROTO_NONE, 0); }
#line 2849 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 48:
#line 628 "cfg.y" /* yacc.c:1646  */
    { IFOR();
		 		(yyval.sockid)=mk_listen_id((yyvsp[0].strval), PROTO_NONE, 0); }
#line 2856 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 49:
#line 630 "cfg.y" /* yacc.c:1646  */
    { IFOR();
		 		(yyval.sockid)=mk_listen_id((yyvsp[-2].strval), PROTO_NONE, (yyvsp[0].intval)); }
#line 2863 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 50:
#line 632 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.sockid)=0;
				yyerror(" port number expected");
				}
#line 2872 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 52:
#line 639 "cfg.y" /* yacc.c:1646  */
    { IFOR();  (yyval.sockid)=(yyvsp[0].sockid) ; }
#line 2878 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 53:
#line 640 "cfg.y" /* yacc.c:1646  */
    { IFOR(); (yyval.sockid)=(yyvsp[-1].sockid); (yyval.sockid)->next=(yyvsp[0].sockid); }
#line 2884 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 54:
#line 643 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					(yyval.sockid)=mk_listen_id((yyvsp[0].strval), PROTO_NONE, 0); }
#line 2891 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 55:
#line 645 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			 		(yyval.sockid)=mk_listen_id((yyvsp[-2].strval), PROTO_NONE, (yyvsp[0].intval)); }
#line 2898 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 56:
#line 647 "cfg.y" /* yacc.c:1646  */
    {
					(yyval.sockid)=0;
					yyerror(" port number expected");
					}
#line 2907 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 57:
#line 653 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					p_tmp.flags |= SI_IS_ANYCAST;
					}
#line 2915 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 58:
#line 656 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					p_tmp.flags |= SI_FRAG;
					}
#line 2923 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 59:
#line 659 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					p_tmp.flags |= SI_REUSEPORT;
					}
#line 2931 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 60:
#line 662 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					p_tmp.workers=(yyvsp[0].intval);
					}
#line 2939 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 61:
#line 665 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					p_tmp.socket = (yyvsp[0].sockid);
					}
#line 2947 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 62:
#line 668 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					p_tmp.tag = (yyvsp[0].strval);
					}
#line 2955 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 63:
#line 671 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					p_tmp.auto_scaling_profile=(yyvsp[0].strval);
					}
#line 2963 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 66:
#line 680 "cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=(yyvsp[0].sockid); }
#line 2969 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 67:
#line 681 "cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=(yyvsp[0].sockid); }
#line 2975 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 68:
#line 682 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					memset(&p_tmp, 0, sizeof(p_tmp));
				}
#line 2983 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 69:
#line 684 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					(yyval.sockid)=(yyvsp[-2].sockid); fill_socket_id(&p_tmp, (yyval.sockid));
				}
#line 2991 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 70:
#line 687 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					memset(&p_tmp, 0, sizeof(p_tmp));
				}
#line 2999 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 71:
#line 689 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					(yyval.sockid)=(yyvsp[-2].sockid); fill_socket_id(&p_tmp, (yyval.sockid));
				}
#line 3007 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 72:
#line 694 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_NONE; }
#line 3013 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 73:
#line 695 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=(yyvsp[0].intval); }
#line 3019 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 74:
#line 697 "cfg.y" /* yacc.c:1646  */
    {  IFOR(); (yyval.multistr)=new_string((yyvsp[0].strval)); }
#line 3025 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 75:
#line 698 "cfg.y" /* yacc.c:1646  */
    { IFOR(); (yyval.multistr)=new_string((yyvsp[-1].strval)); (yyval.multistr)->next=(yyvsp[0].multistr); }
#line 3031 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 76:
#line 701 "cfg.y" /* yacc.c:1646  */
    {
				IFOR(pkg_free((yyvsp[-5].ipnet)));
				s_tmp.s=(yyvsp[-1].strval);
				s_tmp.len=strlen((yyvsp[-1].strval));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-5].ipnet),&s_tmp,(yyvsp[-3].intval),(yyvsp[-7].intval),0)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 3044 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 77:
#line 709 "cfg.y" /* yacc.c:1646  */
    {
				IFOR(pkg_free((yyvsp[-5].ipnet)));
				s_tmp.s=(yyvsp[-1].strval);
				s_tmp.len=strlen((yyvsp[-1].strval));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-5].ipnet),&s_tmp,
				(yyvsp[-3].intval),(yyvsp[-7].intval),BLR_APPLY_CONTRARY)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 3058 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 78:
#line 718 "cfg.y" /* yacc.c:1646  */
    {
				IFOR(pkg_free((yyvsp[-3].ipnet)));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-3].ipnet),NULL,(yyvsp[-1].intval),(yyvsp[-5].intval),0)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 3069 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 79:
#line 724 "cfg.y" /* yacc.c:1646  */
    {
				IFOR(pkg_free((yyvsp[-3].ipnet)));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-3].ipnet),NULL,
				(yyvsp[-1].intval),(yyvsp[-5].intval),BLR_APPLY_CONTRARY)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 3081 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 80:
#line 731 "cfg.y" /* yacc.c:1646  */
    {
				IFOR(pkg_free((yyvsp[-1].ipnet)));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-1].ipnet),NULL,0,(yyvsp[-3].intval),0)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 3092 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 81:
#line 737 "cfg.y" /* yacc.c:1646  */
    {
				IFOR(pkg_free((yyvsp[-1].ipnet)));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-1].ipnet),NULL,
				0,(yyvsp[-3].intval),BLR_APPLY_CONTRARY)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 3104 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 82:
#line 744 "cfg.y" /* yacc.c:1646  */
    {
				IFOR(pkg_free((yyvsp[-3].ipnet)));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-3].ipnet),NULL,(yyvsp[-1].intval),PROTO_NONE,0)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 3115 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 83:
#line 750 "cfg.y" /* yacc.c:1646  */
    {
				IFOR(pkg_free((yyvsp[-3].ipnet)));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-3].ipnet),NULL,
				(yyvsp[-1].intval),PROTO_NONE,BLR_APPLY_CONTRARY)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 3127 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 84:
#line 757 "cfg.y" /* yacc.c:1646  */
    {
				IFOR(pkg_free((yyvsp[-1].ipnet)));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-1].ipnet),NULL,0,PROTO_NONE,0)) {
					yyerror("failed to add backlist element\n"); YYABORT;
				}
			}
#line 3138 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 85:
#line 763 "cfg.y" /* yacc.c:1646  */
    {
				IFOR(pkg_free((yyvsp[-1].ipnet)));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-1].ipnet),NULL,
				0,PROTO_NONE,BLR_APPLY_CONTRARY)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 3150 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 86:
#line 770 "cfg.y" /* yacc.c:1646  */
    {
				IFOR(pkg_free((yyvsp[0].ipnet)));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[0].ipnet),NULL,0,PROTO_NONE,0)) {
					yyerror("failed to add backlist element\n"); YYABORT;
				}
			}
#line 3161 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 87:
#line 776 "cfg.y" /* yacc.c:1646  */
    {
				IFOR(pkg_free((yyvsp[0].ipnet)));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[0].ipnet),NULL,
				0,PROTO_NONE,BLR_APPLY_CONTRARY)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 3173 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 91:
#line 790 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = BL_READONLY_LIST; }
#line 3179 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 92:
#line 791 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = BL_DO_EXPIRE; }
#line 3185 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 93:
#line 792 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = BL_BY_DEFAULT; }
#line 3191 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 94:
#line 795 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = (yyvsp[-2].intval) | (yyvsp[0].intval); }
#line 3197 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 95:
#line 796 "cfg.y" /* yacc.c:1646  */
    {}
#line 3203 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 96:
#line 799 "cfg.y" /* yacc.c:1646  */
    {}
#line 3209 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 97:
#line 800 "cfg.y" /* yacc.c:1646  */
    {}
#line 3215 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 98:
#line 801 "cfg.y" /* yacc.c:1646  */
    { yyerror("bad black list element");}
#line 3221 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 99:
#line 808 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			if (create_auto_scaling_profile((yyvsp[-17].strval),(yyvsp[-15].intval),(yyvsp[-13].intval),(yyvsp[-10].intval),(yyvsp[-8].intval),
			(yyvsp[-6].intval), (yyvsp[-4].intval), (yyvsp[-1].intval),10*(yyvsp[-1].intval))<0)
				yyerror("failed to create auto scaling profile");
		 }
#line 3231 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 100:
#line 816 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			if (create_auto_scaling_profile((yyvsp[-16].strval),(yyvsp[-14].intval),(yyvsp[-12].intval),(yyvsp[-9].intval),(yyvsp[-9].intval),
			(yyvsp[-6].intval), (yyvsp[-4].intval), (yyvsp[-1].intval), 10*(yyvsp[-1].intval))<0)
				yyerror("failed to create auto scaling profile");
		 }
#line 3241 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 101:
#line 822 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			if (create_auto_scaling_profile((yyvsp[-9].strval),(yyvsp[-7].intval),(yyvsp[-5].intval),(yyvsp[-2].intval),(yyvsp[0].intval),
			0, 0, 0, 0)<0)
				yyerror("failed to create auto scaling profile");
		}
#line 3251 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 102:
#line 828 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			if (create_auto_scaling_profile((yyvsp[-8].strval),(yyvsp[-6].intval),(yyvsp[-4].intval),(yyvsp[-1].intval),(yyvsp[-1].intval),
			0, 0, 0, 0)<0)
				yyerror("failed to create auto scaling profile");
		}
#line 3261 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 103:
#line 835 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			/* in debug mode, force logging to DEBUG level*/
			*log_level = debug_mode?L_DBG:(yyvsp[0].intval);
			}
#line 3270 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 104:
#line 839 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			if (*(yyvsp[0].strval)) {
				int len = strlen((yyvsp[0].strval));
				char *buf = pkg_malloc(len + 2);
				if (!buf)
					yyerror("oom");
				sprintf(buf, "%s:", (yyvsp[0].strval));
				log_prefix = buf;
			} else {
				log_prefix = (yyvsp[0].strval);
			}
			}
#line 3287 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 105:
#line 851 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 3293 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 106:
#line 852 "cfg.y" /* yacc.c:1646  */
    { IFOR(); enable_asserts=(yyvsp[0].intval); }
#line 3299 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 107:
#line 853 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3305 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 108:
#line 854 "cfg.y" /* yacc.c:1646  */
    { IFOR(); abort_on_assert=(yyvsp[0].intval); }
#line 3311 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 109:
#line 855 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3317 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 110:
#line 856 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			debug_mode=(yyvsp[0].intval);
			if (debug_mode) {
				*log_level = L_DBG;
				stderr_enabled=1;
				syslog_enabled=0;

				s_tmp.s=STDERR_CONSUMER_NAME;
				s_tmp.len=strlen(STDERR_CONSUMER_NAME);
				set_log_consumer_mute_state(&s_tmp, 0);
				s_tmp.s=SYSLOG_CONSUMER_NAME;
				s_tmp.len=strlen(SYSLOG_CONSUMER_NAME);
				set_log_consumer_mute_state(&s_tmp, 1);
			}
			}
#line 3337 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 111:
#line 872 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected for debug_mode"); }
#line 3343 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 112:
#line 875 "cfg.y" /* yacc.c:1646  */
    { IFOR(); log_stdout=(yyvsp[0].intval); }
#line 3349 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 113:
#line 876 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3355 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 114:
#line 877 "cfg.y" /* yacc.c:1646  */
    {
			IFOR();
			warn("'log_stderror' is deprecated, use 'stderror_enabled' and/or"
				"'syslog_enabled' instead");
			if (!config_check && !debug_mode) {
				if ((yyvsp[0].intval)) {
					stderr_enabled=1;
					syslog_enabled=0;
				} else {
					stderr_enabled=0;
					syslog_enabled=1;
				}

				s_tmp.s=STDERR_CONSUMER_NAME;
				s_tmp.len=strlen(STDERR_CONSUMER_NAME);
				set_log_consumer_mute_state(&s_tmp, !(yyvsp[0].intval));
				s_tmp.s=SYSLOG_CONSUMER_NAME;
				s_tmp.len=strlen(SYSLOG_CONSUMER_NAME);
				set_log_consumer_mute_state(&s_tmp, (yyvsp[0].intval));
			}
			}
#line 3381 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 115:
#line 898 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3387 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 116:
#line 899 "cfg.y" /* yacc.c:1646  */
    {
			/* in config-check or debug mode we force logging
			 * to standard error */
			IFOR();
			if (!config_check && !debug_mode) {
				stderr_enabled=(yyvsp[0].intval);
				s_tmp.s=STDERR_CONSUMER_NAME;
				s_tmp.len=strlen(STDERR_CONSUMER_NAME);
				set_log_consumer_mute_state(&s_tmp, !(yyvsp[0].intval));
			}
			}
#line 3403 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 117:
#line 910 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3409 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 118:
#line 911 "cfg.y" /* yacc.c:1646  */
    {
			IFOR();
			/* in config-check or debug mode we force logging
			 * to standard error */
			if (!config_check && !debug_mode) {
				syslog_enabled=(yyvsp[0].intval);
				s_tmp.s=SYSLOG_CONSUMER_NAME;
				s_tmp.len=strlen(SYSLOG_CONSUMER_NAME);
				set_log_consumer_mute_state(&s_tmp, !(yyvsp[0].intval));
			}
			}
#line 3425 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 119:
#line 922 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3431 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 120:
#line 923 "cfg.y" /* yacc.c:1646  */
    {
			IFOR();
			if ((yyvsp[0].intval)) {
				if (init_log_msg_buf(0) < 0) {
					yyerror("failed to allocate msg log buffer");
					YYABORT;
				}
			}
			log_event_enabled=(yyvsp[0].intval); }
#line 3445 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 121:
#line 932 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3451 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 122:
#line 933 "cfg.y" /* yacc.c:1646  */
    {
			IFOR();
			s_tmp.s=STDERR_CONSUMER_NAME;
			s_tmp.len=strlen(STDERR_CONSUMER_NAME);
			set_log_consumer_level_filter(&s_tmp, (yyvsp[0].intval));
			}
#line 3462 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 123:
#line 939 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3468 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 124:
#line 940 "cfg.y" /* yacc.c:1646  */
    {
			IFOR();
			s_tmp.s=SYSLOG_CONSUMER_NAME;
			s_tmp.len=strlen(SYSLOG_CONSUMER_NAME);
			set_log_consumer_level_filter(&s_tmp, (yyvsp[0].intval));
			}
#line 3479 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 125:
#line 946 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3485 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 126:
#line 947 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			s_tmp.s = (yyvsp[0].strval);
			s_tmp.len = strlen((yyvsp[0].strval));
			if ((i_tmp = parse_log_format(&s_tmp)) < 0) {
				yyerror("unknown log format");
			} else {
				if (i_tmp != LOG_FORMAT_PLAIN) {
					if (init_log_json_buf(0) < 0) {
						yyerror("failed to allocate json log buffer");
						YYABORT;
					}
					if (init_log_msg_buf(0) < 0) {
						yyerror("failed to allocate msg log buffer");
						YYABORT;
					}
				}

				stderr_log_format = i_tmp;
			}
			}
#line 3510 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 127:
#line 967 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			s_tmp.s = (yyvsp[0].strval);
			s_tmp.len = strlen((yyvsp[0].strval));
			if ((i_tmp = parse_log_format(&s_tmp)) < 0) {
				yyerror("unknown log format");
			} else {
				if (i_tmp != LOG_FORMAT_PLAIN) {
					if (init_log_json_buf(0) < 0) {
						yyerror("failed to allocate json log buffer");
						YYABORT;
					}
					if (init_log_msg_buf(0) < 0) {
						yyerror("failed to allocate msg log buffer");
						YYABORT;
					}
				}

				syslog_log_format = i_tmp;
			}
			}
#line 3535 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 128:
#line 987 "cfg.y" /* yacc.c:1646  */
    {
			IFOR();
			log_json_buf_size = (yyvsp[0].intval);
			if (init_log_json_buf(1) < 0) {
				yyerror("failed to realloc json log buffer");
				YYABORT;
			}
			}
#line 3548 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 129:
#line 995 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3554 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 130:
#line 996 "cfg.y" /* yacc.c:1646  */
    {
			IFOR();
			log_msg_buf_size = (yyvsp[0].intval);
			if (init_log_msg_buf(1) < 0) {
				yyerror("failed to realloc msg log buffer");
				YYABORT;
			}
			}
#line 3567 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 131:
#line 1004 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3573 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 132:
#line 1005 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			warn("'log_facility' is deprecated, use 'syslog_facility' instead");
			if ( (i_tmp=str2facility((yyvsp[0].strval)))==-1)
				yyerror("bad facility (see syslog(3) man page)");
			if (!config_check)
				log_facility=i_tmp;
			}
#line 3585 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 133:
#line 1012 "cfg.y" /* yacc.c:1646  */
    { yyerror("ID expected"); }
#line 3591 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 134:
#line 1013 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			if ( (i_tmp=str2facility((yyvsp[0].strval)))==-1)
				yyerror("bad facility (see syslog(3) man page)");
			if (!config_check)
				log_facility=i_tmp;
			}
#line 3602 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 135:
#line 1019 "cfg.y" /* yacc.c:1646  */
    { yyerror("ID expected"); }
#line 3608 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 136:
#line 1020 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			warn("'log_name' is deprecated, use 'syslog_name' instead");
			log_name=(yyvsp[0].strval); }
#line 3616 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 137:
#line 1023 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 3622 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 138:
#line 1024 "cfg.y" /* yacc.c:1646  */
    { IFOR(); log_name=(yyvsp[0].strval); }
#line 3628 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 139:
#line 1025 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 3634 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 140:
#line 1026 "cfg.y" /* yacc.c:1646  */
    { IFOR(); received_dns|= ((yyvsp[0].intval))?DO_DNS:0; }
#line 3640 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 141:
#line 1027 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3646 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 142:
#line 1028 "cfg.y" /* yacc.c:1646  */
    { IFOR(); received_dns|= ((yyvsp[0].intval))?DO_REV_DNS:0; }
#line 3652 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 143:
#line 1029 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3658 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 144:
#line 1030 "cfg.y" /* yacc.c:1646  */
    { IFOR(); dns_try_ipv6=(yyvsp[0].intval); }
#line 3664 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 145:
#line 1031 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3670 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 146:
#line 1032 "cfg.y" /* yacc.c:1646  */
    { IFOR(); dns_try_naptr=(yyvsp[0].intval); }
#line 3676 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 147:
#line 1033 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3682 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 148:
#line 1034 "cfg.y" /* yacc.c:1646  */
    { IFOR(); dns_retr_time=(yyvsp[0].intval); }
#line 3688 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 149:
#line 1035 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3694 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 150:
#line 1036 "cfg.y" /* yacc.c:1646  */
    { IFOR(); dns_retr_no=(yyvsp[0].intval); }
#line 3700 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 151:
#line 1037 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3706 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 152:
#line 1038 "cfg.y" /* yacc.c:1646  */
    { IFOR(); dns_servers_no=(yyvsp[0].intval); }
#line 3712 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 153:
#line 1039 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3718 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 154:
#line 1040 "cfg.y" /* yacc.c:1646  */
    { IFOR(); dns_search_list=(yyvsp[0].intval); }
#line 3724 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 155:
#line 1041 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3730 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 156:
#line 1042 "cfg.y" /* yacc.c:1646  */
    { IFOR(); max_while_loops=(yyvsp[0].intval); }
#line 3736 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 157:
#line 1043 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3742 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 158:
#line 1044 "cfg.y" /* yacc.c:1646  */
    { IFOR(); maxbuffer=(yyvsp[0].intval); }
#line 3748 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 159:
#line 1045 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3754 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 160:
#line 1046 "cfg.y" /* yacc.c:1646  */
    { IFOR(); udp_workers_no=(yyvsp[0].intval); }
#line 3760 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 161:
#line 1047 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				udp_workers_no=(yyvsp[-2].intval);
				udp_auto_scaling_profile=(yyvsp[0].strval);
		}
#line 3769 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 162:
#line 1051 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3775 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 163:
#line 1052 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				timer_workers_no=(yyvsp[0].intval);
		}
#line 3783 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 164:
#line 1055 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				timer_workers_no=(yyvsp[-2].intval);
				timer_auto_scaling_profile=(yyvsp[0].strval);
		}
#line 3792 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 165:
#line 1059 "cfg.y" /* yacc.c:1646  */
    { check_via=(yyvsp[0].intval); }
#line 3798 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 166:
#line 1060 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3804 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 167:
#line 1061 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifdef HP_MALLOC
			shm_hash_split_percentage=(yyvsp[0].intval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3817 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 168:
#line 1069 "cfg.y" /* yacc.c:1646  */
    {
			#ifdef HP_MALLOC
			yyerror("number expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
				}
#line 3830 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 169:
#line 1077 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifdef HP_MALLOC
			shm_secondary_hash_size=(yyvsp[0].intval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with support"
				" for HP_MALLOC\n");
			#endif
			}
#line 3843 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 170:
#line 1085 "cfg.y" /* yacc.c:1646  */
    {
			#ifdef HP_MALLOC
			yyerror("number expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3856 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 171:
#line 1093 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifdef HP_MALLOC
			mem_warming_enabled = (yyvsp[0].intval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with support"
				" for HP_MALLOC\n");
			#endif
			}
#line 3869 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 172:
#line 1101 "cfg.y" /* yacc.c:1646  */
    {
			#ifdef HP_MALLOC
			yyerror("number expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3882 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 173:
#line 1109 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifdef HP_MALLOC
			mem_warming_pattern_file = (yyvsp[0].strval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with "
				"support for HP_MALLOC\n");
			#endif
			}
#line 3895 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 174:
#line 1117 "cfg.y" /* yacc.c:1646  */
    {
			#ifdef HP_MALLOC
			yyerror("string expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3908 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 175:
#line 1125 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifdef HP_MALLOC
			mem_warming_percentage = (yyvsp[0].intval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with "
				"support for HP_MALLOC\n");
			#endif
			}
#line 3921 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 176:
#line 1133 "cfg.y" /* yacc.c:1646  */
    {
			#ifdef HP_MALLOC
			yyerror("number expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3934 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 177:
#line 1141 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			rpm_mem_file = (yyvsp[0].strval);
			}
#line 3942 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 178:
#line 1144 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 3948 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 179:
#line 1145 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			rpm_mem_size = (yyvsp[0].intval) * 1024 * 1024;
			}
#line 3956 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 180:
#line 1148 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 3962 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 181:
#line 1149 "cfg.y" /* yacc.c:1646  */
    { IFOR(); memlog=(yyvsp[0].intval); memdump=(yyvsp[0].intval); }
#line 3968 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 182:
#line 1150 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 3974 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 183:
#line 1151 "cfg.y" /* yacc.c:1646  */
    { IFOR(); shm_memlog_size=(yyvsp[0].intval);}
#line 3980 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 184:
#line 1152 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 3986 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 185:
#line 1153 "cfg.y" /* yacc.c:1646  */
    { IFOR(); memdump=(yyvsp[0].intval); }
#line 3992 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 186:
#line 1154 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 3998 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 187:
#line 1155 "cfg.y" /* yacc.c:1646  */
    {  IFOR();execmsgthreshold=(yyvsp[0].intval); }
#line 4004 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 188:
#line 1156 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 4010 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 189:
#line 1157 "cfg.y" /* yacc.c:1646  */
    { IFOR(); execdnsthreshold=(yyvsp[0].intval); }
#line 4016 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 190:
#line 1158 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 4022 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 191:
#line 1159 "cfg.y" /* yacc.c:1646  */
    { IFOR(); tcpthreshold=(yyvsp[0].intval); }
#line 4028 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 192:
#line 1160 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 4034 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 193:
#line 1161 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifdef STATISTICS
			if ((yyvsp[0].intval) < 0 || (yyvsp[0].intval) > 100)
				yyerror("SHM threshold has to be a percentage between"
					" 0 and 100");
			event_shm_threshold=(yyvsp[0].intval);
			#else
			yyerror("statistics support not compiled in");
			#endif /* STATISTICS */
			}
#line 4049 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 194:
#line 1171 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 4055 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 195:
#line 1172 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifdef PKG_MALLOC
			#ifdef STATISTICS
			if ((yyvsp[0].intval) < 0 || (yyvsp[0].intval) > 100)
				yyerror("PKG threshold has to be a percentage between "
					"0 and 100");
			event_pkg_threshold=(yyvsp[0].intval);
			#else
			yyerror("statistics support not compiled in");
			#endif
			#else
			yyerror("pkg_malloc support not compiled in");
			#endif
			}
#line 4074 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 196:
#line 1186 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 4080 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 197:
#line 1187 "cfg.y" /* yacc.c:1646  */
    { IFOR(); query_buffer_size=(yyvsp[0].intval); }
#line 4086 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 198:
#line 1188 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 4092 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 199:
#line 1189 "cfg.y" /* yacc.c:1646  */
    { IFOR(); query_flush_time=(yyvsp[0].intval); }
#line 4098 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 200:
#line 1190 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 4104 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1191 "cfg.y" /* yacc.c:1646  */
    { IFOR(); sip_warning=(yyvsp[0].intval); }
#line 4110 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1192 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 4116 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1193 "cfg.y" /* yacc.c:1646  */
    { IFOR(); chroot_dir=(yyvsp[0].strval); }
#line 4122 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1194 "cfg.y" /* yacc.c:1646  */
    { IFOR(); chroot_dir=(yyvsp[0].strval); }
#line 4128 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 205:
#line 1195 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 4134 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 206:
#line 1196 "cfg.y" /* yacc.c:1646  */
    { IFOR(); working_dir=(yyvsp[0].strval); }
#line 4140 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 207:
#line 1197 "cfg.y" /* yacc.c:1646  */
    { IFOR(); working_dir=(yyvsp[0].strval); }
#line 4146 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 208:
#line 1198 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 4152 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 209:
#line 1199 "cfg.y" /* yacc.c:1646  */
    { IFOR(); mhomed=(yyvsp[0].intval); }
#line 4158 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 210:
#line 1200 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 4164 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 211:
#line 1201 "cfg.y" /* yacc.c:1646  */
    { IFOR();
									io_poll_method=get_poll_type((yyvsp[0].strval));
									if (io_poll_method==POLL_NONE){
										LM_CRIT("bad poll method name:"
											" %s\n, try one of %s.\n",
											(yyvsp[0].strval), poll_support);
										yyerror("bad poll_method "
											"value");
									}
								}
#line 4179 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 212:
#line 1211 "cfg.y" /* yacc.c:1646  */
    { IFOR();
									io_poll_method=get_poll_type((yyvsp[0].strval));
									if (io_poll_method==POLL_NONE){
										LM_CRIT("bad poll method name:"
											" %s\n, try one of %s.\n",
											(yyvsp[0].strval), poll_support);
										yyerror("bad poll_method "
											"value");
									}
									}
#line 4194 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 213:
#line 1221 "cfg.y" /* yacc.c:1646  */
    { yyerror("poll method name expected"); }
#line 4200 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 214:
#line 1222 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				if ((yyvsp[0].intval) < TCP_ALIAS_NEVER || (yyvsp[0].intval) > TCP_ALIAS_ALWAYS)
					yyerror("invalid 'tcp_accept_aliases' value");
				tcp_accept_aliases=(yyvsp[0].intval);
		}
#line 4210 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 215:
#line 1227 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 4216 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 216:
#line 1228 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_workers_no=(yyvsp[0].intval);
		}
#line 4224 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 217:
#line 1231 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_workers_no=(yyvsp[-2].intval);
				tcp_auto_scaling_profile=(yyvsp[0].strval);
		}
#line 4233 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 218:
#line 1235 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 4239 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 219:
#line 1236 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				if ((yyvsp[0].intval) <= 0)
					yyerror("invalid 'tcp_connect_timeout' (value too low!)");
				tcp_connect_timeout=(yyvsp[0].intval);
		}
#line 4249 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 220:
#line 1241 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 4255 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 221:
#line 1242 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_con_lifetime=(yyvsp[0].intval);
		}
#line 4263 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 222:
#line 1245 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 4269 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 223:
#line 1246 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_socket_backlog=(yyvsp[0].intval);
		}
#line 4277 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 224:
#line 1249 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 4283 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 225:
#line 1250 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_max_connections=(yyvsp[0].intval);
		}
#line 4291 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 226:
#line 1253 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 4297 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 227:
#line 1254 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_no_new_conn_bflag =
					get_flag_id_by_name(FLAG_TYPE_BRANCH, (yyvsp[0].strval), 0);
				if (!flag_in_range( (flag_t)tcp_no_new_conn_bflag ) )
					yyerror("invalid TCP no_new_conn Branch Flag");
				flag_idx2mask( &tcp_no_new_conn_bflag );
		}
#line 4309 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 228:
#line 1261 "cfg.y" /* yacc.c:1646  */
    { yyerror("number value expected"); }
#line 4315 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 229:
#line 1262 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_no_new_conn_rplflag =
					get_flag_id_by_name(FLAG_TYPE_MSG, (yyvsp[0].strval), 0);
				if (!flag_in_range( (flag_t)tcp_no_new_conn_rplflag ) )
					yyerror("invalid TCP no_new_conn RePLy Flag");
				flag_idx2mask( &tcp_no_new_conn_rplflag );
		}
#line 4327 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 230:
#line 1269 "cfg.y" /* yacc.c:1646  */
    { yyerror("number value expected"); }
#line 4333 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 231:
#line 1271 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_keepalive=!!(yyvsp[0].intval);
		}
#line 4341 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 232:
#line 1274 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 4347 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 233:
#line 1275 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_max_msg_time=(yyvsp[0].intval);
		}
#line 4355 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 234:
#line 1278 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 4361 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 235:
#line 1279 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_parallel_read_on_workers=!!(yyvsp[0].intval);
		}
#line 4369 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 236:
#line 1282 "cfg.y" /* yacc.c:1646  */
    {
			yyerror("boolean value expected");
		}
#line 4377 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1285 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifndef HAVE_TCP_KEEPCNT
				warn("cannot be enabled TCP_KEEPCOUNT (no OS support)");
			#else
				tcp_keepcount=(yyvsp[0].intval);
			#endif
		}
#line 4389 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1292 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 4395 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1293 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifndef HAVE_TCP_KEEPIDLE
				warn("cannot be enabled TCP_KEEPIDLE (no OS support)");
			#else
				tcp_keepidle=(yyvsp[0].intval);
			#endif
		}
#line 4407 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1300 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 4413 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1301 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifndef HAVE_TCP_KEEPINTVL
				warn("cannot be enabled TCP_KEEPINTERVAL (no OS support)");
			#else
				tcp_keepinterval=(yyvsp[0].intval);
			 #endif
		}
#line 4425 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1308 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 4431 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1309 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							server_signature=(yyvsp[0].intval); }
#line 4438 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1311 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 4444 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1312 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							server_header->s=(yyvsp[0].strval);
							server_header->len=strlen((yyvsp[0].strval));
							}
#line 4453 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 246:
#line 1316 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 4459 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1317 "cfg.y" /* yacc.c:1646  */
    { user_agent_header->s=(yyvsp[0].strval);
			user_agent_header->len=strlen((yyvsp[0].strval));
									}
#line 4467 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1320 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 4473 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1321 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							pv_print_buf_size = (yyvsp[0].intval); }
#line 4480 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1323 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 4486 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1324 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							xlog_buf_size = (yyvsp[0].intval); }
#line 4493 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1326 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							xlog_force_color = (yyvsp[0].intval); }
#line 4500 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1328 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							xlog_print_level = (yyvsp[0].intval); }
#line 4507 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1330 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 4513 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1331 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 4519 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1332 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 4525 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1333 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							*xlog_level = (yyvsp[0].intval); }
#line 4532 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1335 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 4538 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1336 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							if (add_listening_socket((yyvsp[0].sockid))!=0){
								LM_CRIT("cfg. parser: failed"
										" to add listening socket\n");
								break;
							}
						}
#line 4550 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1343 "cfg.y" /* yacc.c:1646  */
    { yyerror("ip address or hostname "
						"expected (use quotes if the hostname includes"
						" config keywords)"); }
#line 4558 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 261:
#line 1346 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							warn("'listen' is deprecated, use 'socket' instead");
							if (add_listening_socket((yyvsp[0].sockid))!=0){
								LM_CRIT("cfg. parser: failed"
										" to add listen address\n");
								break;
							}
						}
#line 4571 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 262:
#line 1354 "cfg.y" /* yacc.c:1646  */
    { yyerror("ip address or hostname "
						"expected (use quotes if the hostname includes"
						" config keywords)"); }
#line 4579 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 263:
#line 1357 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							/* convert STIRNG ($3) to an ID */
							/* update the memstats type for each module */
							#ifndef SHM_EXTRA_STATS
								LM_CRIT("SHM_EXTRA_STATS not defined");
								YYABORT;
							#else

							#ifdef SHM_SHOW_DEFAULT_GROUP
							if(strcmp((yyvsp[-2].strval), "default") == 0){
								LM_CRIT("default group  name is not allowed");
								YYABORT;
							}
							#endif

							for(tmp_mod = mod_names; tmp_mod; tmp_mod=tmp_mod->next){
								if(strcmp((yyvsp[-2].strval), tmp_mod->s) == 0){
									LM_CRIT("The same mem-group name is used twice: [%s] [%s]\n", (yyvsp[-2].strval), tmp_mod->s);
									YYABORT;
								}
							}

							tmp_mod = pkg_malloc(sizeof(struct multi_str));
							if(!tmp_mod){
								LM_CRIT("out of pkg memory");
								YYABORT;
							}

							tmp_mod->s = (yyvsp[-2].strval);
							tmp_mod->next = mod_names;
							mod_names = tmp_mod;
							for (tmp_mod = (yyvsp[0].multistr); tmp_mod; tmp_mod = tmp_mod->next){
								if(set_mem_idx(tmp_mod->s, mem_free_idx)){
									YYABORT;
								}
							}

							mem_free_idx++;

							if(alloc_group_stat()){
								YYABORT;
							}
							#endif
						}
#line 4628 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 264:
#line 1401 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid or no module specified"); }
#line 4634 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 265:
#line 1402 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							for(lst_tmp=(yyvsp[0].sockid); lst_tmp; lst_tmp=lst_tmp->next)
								add_alias(lst_tmp->name, strlen(lst_tmp->name),
											lst_tmp->port, lst_tmp->proto);
							  }
#line 4644 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 266:
#line 1407 "cfg.y" /* yacc.c:1646  */
    { yyerror("hostname expected (use quotes"
							" if the hostname includes config keywords)"); }
#line 4651 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 267:
#line 1409 "cfg.y" /* yacc.c:1646  */
    { IFOR();
								auto_aliases=(yyvsp[0].intval); }
#line 4658 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 268:
#line 1411 "cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 4664 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 269:
#line 1412 "cfg.y" /* yacc.c:1646  */
    { IFOR();
								if ((yyvsp[0].strval)) {
									default_global_address->s=(yyvsp[0].strval);
									default_global_address->len=strlen((yyvsp[0].strval));
								}
								}
#line 4675 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 270:
#line 1418 "cfg.y" /* yacc.c:1646  */
    {yyerror("ip address or hostname "
												"expected"); }
#line 4682 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 271:
#line 1420 "cfg.y" /* yacc.c:1646  */
    { IFOR();
								tmp = int2str((yyvsp[0].intval), &i_tmp);
								if (i_tmp > default_global_port->len)
									default_global_port->s =
									pkg_realloc(default_global_port->s, i_tmp);
								if (!default_global_port->s) {
									LM_CRIT("cfg. parser: out of memory.\n");
									YYABORT;
								} else {
									default_global_port->len = i_tmp;
									memcpy(default_global_port->s, tmp,
											default_global_port->len);
								}
								}
#line 4701 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 272:
#line 1434 "cfg.y" /* yacc.c:1646  */
    {yyerror("ip address or hostname "
												"expected"); }
#line 4708 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 273:
#line 1436 "cfg.y" /* yacc.c:1646  */
    { IFOR();
										disable_core_dump=(yyvsp[0].intval);
									}
#line 4716 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 274:
#line 1439 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 4722 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 275:
#line 1440 "cfg.y" /* yacc.c:1646  */
    { IFOR();
										open_files_limit=(yyvsp[0].intval);
									}
#line 4730 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 276:
#line 1443 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 4736 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 277:
#line 1444 "cfg.y" /* yacc.c:1646  */
    { IFOR();
								#ifdef USE_MCAST
										mcast_loopback=(yyvsp[0].intval);
								#else
									warn("no multicast support compiled in");
								#endif
		  }
#line 4748 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 278:
#line 1451 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 4754 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 279:
#line 1452 "cfg.y" /* yacc.c:1646  */
    { IFOR();
								#ifdef USE_MCAST
										mcast_ttl=(yyvsp[0].intval);
								#else
									warn("no multicast support compiled in");
								#endif
		  }
#line 4766 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 280:
#line 1459 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected as tos"); }
#line 4772 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 281:
#line 1460 "cfg.y" /* yacc.c:1646  */
    { IFOR(); tos = (yyvsp[0].intval);
							if (tos<=0)
								yyerror("invalid tos value");
		 }
#line 4781 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 282:
#line 1464 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							if (strcasecmp((yyvsp[0].strval),"IPTOS_LOWDELAY")) {
								tos=IPTOS_LOWDELAY;
							} else if (strcasecmp((yyvsp[0].strval),"IPTOS_THROUGHPUT")) {
								tos=IPTOS_THROUGHPUT;
							} else if (strcasecmp((yyvsp[0].strval),"IPTOS_RELIABILITY")) {
								tos=IPTOS_RELIABILITY;
#if defined(IPTOS_MINCOST)
							} else if (strcasecmp((yyvsp[0].strval),"IPTOS_MINCOST")) {
								tos=IPTOS_MINCOST;
#endif
#if defined(IPTOS_LOWCOST)
							} else if (strcasecmp((yyvsp[0].strval),"IPTOS_LOWCOST")) {
								tos=IPTOS_LOWCOST;
#endif
							} else {
								yyerror("invalid tos value - allowed: "
									"IPTOS_LOWDELAY,IPTOS_THROUGHPUT,"
									"IPTOS_RELIABILITY"
#if defined(IPTOS_LOWCOST)
									",IPTOS_LOWCOST"
#endif
#if defined(IPTOS_MINCOST)
									",IPTOS_MINCOST"
#endif
									"\n");
							}
		 }
#line 4814 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 283:
#line 1492 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 4820 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 284:
#line 1493 "cfg.y" /* yacc.c:1646  */
    {IFOR();
				set_mpath((yyvsp[0].strval)); }
#line 4827 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 285:
#line 1495 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 4833 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 286:
#line 1496 "cfg.y" /* yacc.c:1646  */
    { IFOR();
										disable_dns_failover=(yyvsp[0].intval);
									}
#line 4841 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 287:
#line 1499 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 4847 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 288:
#line 1500 "cfg.y" /* yacc.c:1646  */
    { IFOR();
										disable_dns_blacklist=(yyvsp[0].intval);
									}
#line 4855 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 289:
#line 1503 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 4861 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 290:
#line 1504 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				s_tmp.s = (yyvsp[-3].strval);
				s_tmp.len = strlen((yyvsp[-3].strval));
				if (create_bl_head(_str("script"), (yyvsp[-1].intval),
				    bl_head, bl_tail, &s_tmp)==0) {
					yyerror("failed to create blacklist\n");
					YYABORT;
				}
				bl_head = bl_tail = NULL;
				}
#line 4876 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 291:
#line 1514 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				s_tmp.s = (yyvsp[-1].strval);
				s_tmp.len = strlen((yyvsp[-1].strval));
				if (create_bl_head(_str("script"), BL_READONLY_LIST,
				    bl_head, bl_tail, &s_tmp)==0) {
					yyerror("failed to create blacklist\n");
					YYABORT;
				}
				bl_head = bl_tail = NULL;
				}
#line 4891 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 292:
#line 1524 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				sl_fwd_disabled=(yyvsp[0].intval); }
#line 4898 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 293:
#line 1526 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				db_version_table=(yyvsp[0].strval); }
#line 4905 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 294:
#line 1528 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 4911 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 295:
#line 1529 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				db_default_url=(yyvsp[0].strval); }
#line 4918 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 296:
#line 1531 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 4924 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 297:
#line 1532 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				db_max_async_connections=(yyvsp[0].intval); }
#line 4931 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 298:
#line 1534 "cfg.y" /* yacc.c:1646  */
    {
				yyerror("integer value expected");
				}
#line 4939 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 299:
#line 1537 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				disable_503_translation=(yyvsp[0].intval); }
#line 4946 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 300:
#line 1539 "cfg.y" /* yacc.c:1646  */
    {
				yyerror("integer value expected");
				}
#line 4954 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 301:
#line 1542 "cfg.y" /* yacc.c:1646  */
    {}
#line 4960 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 302:
#line 1543 "cfg.y" /* yacc.c:1646  */
    {
				yyerror("bad auto-scaling profile definition");
				}
#line 4968 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 303:
#line 1546 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				auto_scaling_cycle=(yyvsp[0].intval); }
#line 4975 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 304:
#line 1548 "cfg.y" /* yacc.c:1646  */
    {
				yyerror("integer value expected");
				}
#line 4983 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 305:
#line 1551 "cfg.y" /* yacc.c:1646  */
    { yyerror("unknown config variable"); }
#line 4989 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 306:
#line 1554 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			if (load_module((yyvsp[0].strval)) < 0)
				yyerrorf("failed to load module %s\n", (yyvsp[0].strval));
		}
#line 4998 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 307:
#line 1558 "cfg.y" /* yacc.c:1646  */
    { yyerror("string expected");  }
#line 5004 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 308:
#line 1559 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				if (set_mod_param_regex((yyvsp[-5].strval), (yyvsp[-3].strval), STR_PARAM, (yyvsp[-1].strval)) != 0) {
					yyerrorf("Parameter <%s> not found in module <%s> - "
						"can't set", (yyvsp[-3].strval), (yyvsp[-5].strval));
				}
			}
#line 5015 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 309:
#line 1565 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				if (set_mod_param_regex((yyvsp[-5].strval), (yyvsp[-3].strval), STR_PARAM, (yyvsp[-1].strval)) != 0) {
					yyerrorf("Parameter <%s> not found in module <%s> - "
						"can't set", (yyvsp[-3].strval), (yyvsp[-5].strval));
				}
			}
#line 5026 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 310:
#line 1571 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				if (set_mod_param_regex((yyvsp[-5].strval), (yyvsp[-3].strval), INT_PARAM, (void*)(yyvsp[-1].intval)) != 0) {
					yyerrorf("Parameter <%s> not found in module <%s> - "
						"can't set", (yyvsp[-3].strval), (yyvsp[-5].strval));
				}
			}
#line 5037 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 311:
#line 1577 "cfg.y" /* yacc.c:1646  */
    { yyerror("Invalid arguments"); }
#line 5043 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 312:
#line 1581 "cfg.y" /* yacc.c:1646  */
    { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 5049 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 313:
#line 1582 "cfg.y" /* yacc.c:1646  */
    { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 5055 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 314:
#line 1585 "cfg.y" /* yacc.c:1646  */
    {
					(yyval.ipaddr)=pkg_malloc(sizeof(struct ip_addr));
					if ((yyval.ipaddr)==0){
						LM_CRIT("ERROR: cfg. parser: out of memory.\n");
						YYABORT;
					}else{
						memset((yyval.ipaddr), 0, sizeof(struct ip_addr));
						(yyval.ipaddr)->af=AF_INET;
						(yyval.ipaddr)->len=16;
						if (inet_pton(AF_INET, (yyvsp[0].strval), (yyval.ipaddr)->u.addr)<=0){
							yyerror("bad ipv4 address");
						}
					}
				}
#line 5074 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 315:
#line 1601 "cfg.y" /* yacc.c:1646  */
    {
					(yyval.ipaddr)=pkg_malloc(sizeof(struct ip_addr));
					if ((yyval.ipaddr)==0){
						LM_CRIT("ERROR: cfg. parser: out of memory.\n");
						YYABORT;
					}else{
						memset((yyval.ipaddr), 0, sizeof(struct ip_addr));
						(yyval.ipaddr)->af=AF_INET6;
						(yyval.ipaddr)->len=16;
						if (inet_pton(AF_INET6, (yyvsp[0].strval), (yyval.ipaddr)->u.addr)<=0){
							yyerror("bad ipv6 address");
						}
					}
				}
#line 5093 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 316:
#line 1617 "cfg.y" /* yacc.c:1646  */
    { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 5099 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 317:
#line 1618 "cfg.y" /* yacc.c:1646  */
    {(yyval.ipaddr)=(yyvsp[-1].ipaddr); }
#line 5105 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 318:
#line 1621 "cfg.y" /* yacc.c:1646  */
    {
				if (parse_ipnet((yyvsp[0].strval), strlen((yyvsp[0].strval)), &net_tmp) < 0)
					yyerror("unable to parse ip and/or netmask\n");

				(yyval.ipnet) = net_tmp;
			}
#line 5116 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 319:
#line 1627 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.ipnet)=mk_net_bitlen((yyvsp[0].ipaddr), (yyvsp[0].ipaddr)->len*8);
				pkg_free((yyvsp[0].ipaddr));
			}
#line 5125 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 320:
#line 1637 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.strval) = pkg_malloc( strlen((yyvsp[-1].strval)) + strlen((yyvsp[0].strval)) + 1);
				if ((yyval.strval)==0){
					yyerror("cfg. parser: out of memory");
					YYABORT;
				} else {
					strcpy((yyval.strval),(yyvsp[-1].strval)); strcat((yyval.strval),(yyvsp[0].strval));
					pkg_free((yyvsp[-1].strval)); pkg_free((yyvsp[0].strval));
				}
			}
#line 5140 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 321:
#line 1647 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.strval) = pkg_malloc( strlen((yyvsp[-1].strval)) + strlen((yyvsp[0].strval)) + 1);
				if ((yyval.strval)==0){
					LM_CRIT("ERROR: cfg. parser: out of memory.\n");
					YYABORT;
				} else {
					strcpy((yyval.strval),(yyvsp[-1].strval)); strcat((yyval.strval),(yyvsp[0].strval));
					pkg_free((yyvsp[-1].strval)); pkg_free((yyvsp[0].strval));
				}
			}
#line 5155 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 322:
#line 1658 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.strval) = (yyvsp[0].strval);
				}
#line 5163 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 323:
#line 1661 "cfg.y" /* yacc.c:1646  */
    {
				tmp=int2str((yyvsp[0].intval), &i_tmp);
				if (((yyval.strval)=pkg_malloc(i_tmp+1))==0) {
					yyerror("cfg. parser: out of memory.\n");
					YYABORT;
				}
				memcpy( (yyval.strval), tmp, i_tmp);
				(yyval.strval)[i_tmp] = 0;
				}
#line 5177 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 324:
#line 1670 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.strval) = (yyvsp[0].strval);
		}
#line 5185 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 325:
#line 1675 "cfg.y" /* yacc.c:1646  */
    {
				/* check to see if there are any "$" in the string name */
				tmp = strchr((yyvsp[0].strval), '$');
				if (!tmp) {
					/* route name is a cosntant string - search for the route */
					rn_tmp.data = 0;
					rn_tmp.iname = get_script_route_idx((yyvsp[0].strval), sroutes->request,
							RT_NO, 0);
					if (rn_tmp.iname==-1)
						yyerror("too many script routes");
					(yyval.intval) = NUMBER_ST;
				} else {
					tstr.s = (yyvsp[0].strval);
					tstr.len = strlen(tstr.s);
					if (pv_parse_format(&tstr, &elem) < 0) {
						yyerror("cannot parse format");
						YYABORT;
					}
					/* the route name is a format, so we can't evaluate it now */
					rn_tmp.ename = elem;
					(yyval.intval) = SCRIPTVAR_ELEM_ST;
				}
			}
#line 5213 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 326:
#line 1698 "cfg.y" /* yacc.c:1646  */
    {
				rn_tmp.sname = (yyvsp[0].specval);
				(yyval.intval) = SCRIPTVAR_ST;
		}
#line 5222 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 327:
#line 1703 "cfg.y" /* yacc.c:1646  */
    {
						if (sroutes->request[DEFAULT_RT].a!=0) {
							yyerror("overwriting default "
								"request routing table");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->request[DEFAULT_RT].a);
					}
#line 5235 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 328:
#line 1711 "cfg.y" /* yacc.c:1646  */
    {
						if ( strtol((yyvsp[-4].strval),&tmp,10)==0 && *tmp==0) {
							/* route[0] detected */
							if (sroutes->request[DEFAULT_RT].a!=0) {
								yyerror("overwriting(2) default "
									"request routing table");
								YYABORT;
							}
							push((yyvsp[-1].action), &sroutes->request[DEFAULT_RT].a);
						} else {
							i_tmp = get_script_route_idx( (yyvsp[-4].strval),
								sroutes->request, RT_NO,1);
							if (i_tmp==-1) YYABORT;
							push((yyvsp[-1].action), &sroutes->request[i_tmp].a);
						}
					}
#line 5256 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 329:
#line 1727 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid  route  statement"); }
#line 5262 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 330:
#line 1730 "cfg.y" /* yacc.c:1646  */
    {
						i_tmp = get_script_route_idx( (yyvsp[-4].strval), sroutes->failure,
							FAILURE_RT_NO,1);
						if (i_tmp==-1) YYABORT;
						push((yyvsp[-1].action), &sroutes->failure[i_tmp].a);
					}
#line 5273 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 331:
#line 1736 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid failure_route statement"); }
#line 5279 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 332:
#line 1739 "cfg.y" /* yacc.c:1646  */
    {
						if (sroutes->onreply[DEFAULT_RT].a!=0) {
							yyerror("overwriting default "
								"onreply routing table");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->onreply[DEFAULT_RT].a);
					}
#line 5292 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 333:
#line 1747 "cfg.y" /* yacc.c:1646  */
    {
						i_tmp = get_script_route_idx( (yyvsp[-4].strval), sroutes->onreply,
							ONREPLY_RT_NO,1);
						if (i_tmp==-1) YYABORT;
						push((yyvsp[-1].action), &sroutes->onreply[i_tmp].a);
					}
#line 5303 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 334:
#line 1753 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid onreply_route statement"); }
#line 5309 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 335:
#line 1756 "cfg.y" /* yacc.c:1646  */
    {
						i_tmp = get_script_route_idx( (yyvsp[-4].strval), sroutes->branch,
							BRANCH_RT_NO,1);
						if (i_tmp==-1) YYABORT;
						push((yyvsp[-1].action), &sroutes->branch[i_tmp].a);
					}
#line 5320 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 336:
#line 1762 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid branch_route statement"); }
#line 5326 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 337:
#line 1765 "cfg.y" /* yacc.c:1646  */
    {
						if (sroutes->error.a!=0) {
							yyerror("overwriting default "
								"error routing table");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->error.a);
					}
#line 5339 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 338:
#line 1773 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid error_route statement"); }
#line 5345 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 339:
#line 1776 "cfg.y" /* yacc.c:1646  */
    {
						if (sroutes->local.a!=0) {
							yyerror("re-definition of local "
								"route detected");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->local.a);
					}
#line 5358 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 340:
#line 1784 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid local_route statement"); }
#line 5364 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 341:
#line 1787 "cfg.y" /* yacc.c:1646  */
    {
						if (sroutes->startup.a!=0) {
							yyerror("re-definition of startup "
								"route detected");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->startup.a);
					}
#line 5377 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 342:
#line 1795 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid startup_route statement"); }
#line 5383 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 343:
#line 1798 "cfg.y" /* yacc.c:1646  */
    {
						i_tmp = 0;
						while(i_tmp<TIMER_RT_NO && sroutes->timer[i_tmp].a!=0){
							i_tmp++;
						}
						if(i_tmp == TIMER_RT_NO) {
							yyerror("Too many timer routes defined\n");
							YYABORT;
						}
						sroutes->timer[i_tmp].name = (yyvsp[-6].strval);
						sroutes->timer[i_tmp].interval = (yyvsp[-4].intval);
						push((yyvsp[-1].action), &sroutes->timer[i_tmp].a);
					}
#line 5401 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 344:
#line 1811 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid timer_route statement"); }
#line 5407 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 345:
#line 1814 "cfg.y" /* yacc.c:1646  */
    {
						i_tmp = get_script_route_idx((yyvsp[-4].strval), sroutes->event,
								EVENT_RT_NO,1);
						if (i_tmp==-1) YYABORT;
						push((yyvsp[-1].action), &sroutes->event[i_tmp].a);
					}
#line 5418 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 346:
#line 1820 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid event_route statement"); }
#line 5424 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 347:
#line 1825 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_exp(AND_OP, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 5430 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 348:
#line 1826 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_exp(OR_OP, (yyvsp[-2].expr), (yyvsp[0].expr));  }
#line 5436 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 349:
#line 1827 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_exp(NOT_OP, (yyvsp[0].expr), 0);  }
#line 5442 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 350:
#line 1828 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_exp(EVAL_OP, (yyvsp[-1].expr), 0); }
#line 5448 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 351:
#line 1829 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=(yyvsp[-1].expr); }
#line 5454 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 352:
#line 1830 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=(yyvsp[0].expr); }
#line 5460 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 353:
#line 1833 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=EQUAL_OP; }
#line 5466 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 354:
#line 1834 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=DIFF_OP; }
#line 5472 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 355:
#line 1837 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=GT_OP; }
#line 5478 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 356:
#line 1838 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=LT_OP; }
#line 5484 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 357:
#line 1839 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=GTE_OP; }
#line 5490 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 358:
#line 1840 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=LTE_OP; }
#line 5496 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 359:
#line 1842 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=MATCH_OP; }
#line 5502 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 360:
#line 1843 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=NOTMATCH_OP; }
#line 5508 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 361:
#line 1846 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=(yyvsp[0].intval); }
#line 5514 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 362:
#line 1847 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=(yyvsp[0].intval); }
#line 5520 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 363:
#line 1850 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=(yyvsp[0].intval); }
#line 5526 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 364:
#line 1851 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=(yyvsp[0].intval); }
#line 5532 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 365:
#line 1852 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=(yyvsp[0].intval); }
#line 5538 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 366:
#line 1855 "cfg.y" /* yacc.c:1646  */
    {
				spec = (pv_spec_t*)pkg_malloc(sizeof(pv_spec_t));
				if (spec==NULL){
					yyerror("no more pkg memory\n");
					YYABORT;
				}
				memset(spec, 0, sizeof(pv_spec_t));
				tstr.s = (yyvsp[0].strval);
				tstr.len = strlen(tstr.s);
				if(pv_parse_spec(&tstr, spec)==NULL)
				{
					yyerror("unknown script variable");
				}

				(yyval.specval) = spec;
			}
#line 5559 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 367:
#line 1871 "cfg.y" /* yacc.c:1646  */
    {
			(yyval.specval)=0; yyerror("invalid script variable name");
		}
#line 5567 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 368:
#line 1876 "cfg.y" /* yacc.c:1646  */
    {(yyval.expr)=(yyvsp[0].expr); }
#line 5573 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 369:
#line 1877 "cfg.y" /* yacc.c:1646  */
    {(yyval.expr)=mk_elem( NO_OP, ACTION_O, 0, ACTIONS_ST, (yyvsp[0].action) ); }
#line 5579 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 370:
#line 1878 "cfg.y" /* yacc.c:1646  */
    {(yyval.expr)=mk_elem( NO_OP, NUMBER_O, 0, NUMBER_ST,
											(void*)(yyvsp[0].intval) ); }
#line 5586 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 371:
#line 1880 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr)=mk_elem(NO_OP, SCRIPTVAR_O,0,SCRIPTVAR_ST,(void*)(yyvsp[0].specval));
			}
#line 5594 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 372:
#line 1885 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr)=mk_elem( (yyvsp[-1].intval), SCRIPTVAR_O,(void*)(yyvsp[-2].specval),SCRIPTVAR_ST,(void*)(yyvsp[0].specval));
			}
#line 5602 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 373:
#line 1888 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr)=mk_elem( (yyvsp[-1].intval), SCRIPTVAR_O,(void*)(yyvsp[-2].specval),STR_ST,(yyvsp[0].strval));
			}
#line 5610 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 374:
#line 1891 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr)=mk_elem( (yyvsp[-1].intval), SCRIPTVAR_O,(void*)(yyvsp[-2].specval),NUMBER_ST,(void *)(yyvsp[0].intval));
			}
#line 5618 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 375:
#line 1894 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr)=mk_elem( (yyvsp[-1].intval), SCRIPTVAR_O,(void*)(yyvsp[-2].specval), NULLV_ST, 0);
			}
#line 5626 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 376:
#line 1897 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr)=mk_elem((yyvsp[-1].intval), SCRIPTVAR_O, (void*)(yyvsp[-2].specval), NET_ST, (yyvsp[0].ipnet));
			}
#line 5634 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 377:
#line 1903 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = EQ_T; }
#line 5640 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 378:
#line 1904 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = COLONEQ_T; }
#line 5646 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 379:
#line 1905 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = PLUSEQ_T; }
#line 5652 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 380:
#line 1906 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = MINUSEQ_T;}
#line 5658 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 381:
#line 1907 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = DIVEQ_T; }
#line 5664 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 382:
#line 1908 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = MULTEQ_T; }
#line 5670 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 383:
#line 1909 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = MODULOEQ_T; }
#line 5676 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 384:
#line 1910 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = BANDEQ_T; }
#line 5682 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 385:
#line 1911 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = BOREQ_T; }
#line 5688 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 386:
#line 1912 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = BXOREQ_T; }
#line 5694 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 387:
#line 1916 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr) = mk_elem(VALUE_OP, NUMBERV_O, (void*)(yyvsp[0].intval), 0, 0); }
#line 5700 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 388:
#line 1917 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr) = mk_elem(VALUE_OP, STRINGV_O, (yyvsp[0].strval), 0, 0); }
#line 5706 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 389:
#line 1918 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr) = mk_elem(VALUE_OP, SCRIPTVAR_O, (yyvsp[0].specval), 0, 0); }
#line 5712 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 390:
#line 1919 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr)= (yyvsp[0].expr); }
#line 5718 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 391:
#line 1920 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem( NO_OP, ACTION_O, 0, ACTIONS_ST, (yyvsp[0].action) ); }
#line 5724 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 392:
#line 1921 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(PLUS_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5732 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 393:
#line 1924 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(MINUS_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5740 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 394:
#line 1927 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(MULT_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5748 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 395:
#line 1930 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(DIV_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5756 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 396:
#line 1933 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(MODULO_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5764 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 397:
#line 1936 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(BAND_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5772 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 398:
#line 1939 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(BOR_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5780 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 399:
#line 1942 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(BXOR_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5788 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 400:
#line 1945 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(BLSHIFT_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5796 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 401:
#line 1948 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(BRSHIFT_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5804 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 402:
#line 1951 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(BNOT_OP, EXPR_O, (yyvsp[0].expr), 0, 0);
			}
#line 5812 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 403:
#line 1954 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[-1].expr); }
#line 5818 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 404:
#line 1957 "cfg.y" /* yacc.c:1646  */
    {
			if(!pv_is_w((yyvsp[-2].specval)))
				yyerror("invalid left operand in assignment");
			if((yyvsp[-2].specval)->trans!=0)
				yyerror("transformations not accepted in left side "
					"of assignment");

			mk_action2( (yyval.action), (yyvsp[-1].intval),
					SCRIPTVAR_ST,
					EXPR_ST,
					(yyvsp[-2].specval),
					(yyvsp[0].expr));
		}
#line 5836 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 405:
#line 1970 "cfg.y" /* yacc.c:1646  */
    {
			if(!pv_is_w((yyvsp[-2].specval)))
				yyerror("invalid left operand in assignment");
			if((yyvsp[-2].specval)->trans!=0)
				yyerror("transformations not accepted in left side "
					"of assignment");

			mk_action2( (yyval.action), EQ_T,
					SCRIPTVAR_ST,
					NULLV_ST,
					(yyvsp[-2].specval),
					0);
		}
#line 5854 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 406:
#line 1983 "cfg.y" /* yacc.c:1646  */
    {
			if(!pv_is_w((yyvsp[-2].specval)))
				yyerror("invalid left operand in assignment");
			/* not all can get NULL with := */
			switch((yyvsp[-2].specval)->type) {
				case PVT_AVP:
				break;
				default:
					yyerror("invalid left operand in NULL assignment");
			}
			if((yyvsp[-2].specval)->trans!=0)
				yyerror("transformations not accepted in left side "
					"of assignment");

			mk_action2( (yyval.action), COLONEQ_T,
					SCRIPTVAR_ST,
					NULLV_ST,
					(yyvsp[-2].specval),
					0);
		}
#line 5879 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 407:
#line 2005 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[0].action); }
#line 5885 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 408:
#line 2006 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[0].action); }
#line 5891 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 409:
#line 2007 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[0].action); }
#line 5897 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 410:
#line 2008 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[-1].action); }
#line 5903 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 411:
#line 2009 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; }
#line 5909 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 412:
#line 2012 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[0].action); }
#line 5915 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 413:
#line 2013 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[-1].action); }
#line 5921 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 414:
#line 2014 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; }
#line 5927 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 415:
#line 2017 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[0].action); }
#line 5933 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 416:
#line 2018 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[-1].action); }
#line 5939 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 417:
#line 2019 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; }
#line 5945 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 418:
#line 2022 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 5951 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 419:
#line 2023 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 5957 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 420:
#line 2024 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad command!)"); }
#line 5963 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 421:
#line 2028 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 5969 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 422:
#line 2029 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 5975 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 423:
#line 2030 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad command!)"); }
#line 5981 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 424:
#line 2033 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[-1].action);}
#line 5987 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 425:
#line 2034 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 5993 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 426:
#line 2035 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 5999 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 427:
#line 2036 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 6005 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 428:
#line 2037 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 6011 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 429:
#line 2038 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[-1].action);}
#line 6017 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 430:
#line 2039 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=0;}
#line 6023 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 431:
#line 2040 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad command: missing ';'?"); }
#line 6029 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 432:
#line 2043 "cfg.y" /* yacc.c:1646  */
    { mk_action0((yyval.action), BREAK_T);}
#line 6035 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 433:
#line 2044 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[-1].action);}
#line 6041 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 434:
#line 2045 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 6047 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 435:
#line 2046 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 6053 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 436:
#line 2047 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 6059 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 437:
#line 2048 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 6065 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 438:
#line 2049 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[-1].action);}
#line 6071 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 439:
#line 2050 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=0;}
#line 6077 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 440:
#line 2051 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad command: missing ';'?"); }
#line 6083 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 441:
#line 2054 "cfg.y" /* yacc.c:1646  */
    { mk_action3( (yyval.action), IF_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 NOSUBTYPE,
													 (yyvsp[-2].expr),
													 (yyvsp[0].action),
													 0);
									}
#line 6096 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 442:
#line 2062 "cfg.y" /* yacc.c:1646  */
    { mk_action3( (yyval.action), IF_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 ACTIONS_ST,
													 (yyvsp[-4].expr),
													 (yyvsp[-2].action),
													 (yyvsp[0].action));
									}
#line 6109 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 443:
#line 2072 "cfg.y" /* yacc.c:1646  */
    { mk_action3( (yyval.action), IF_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 NOSUBTYPE,
													 (yyvsp[-2].expr),
													 (yyvsp[0].action),
													 0);
									}
#line 6122 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 444:
#line 2080 "cfg.y" /* yacc.c:1646  */
    { mk_action3( (yyval.action), IF_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 ACTIONS_ST,
													 (yyvsp[-4].expr),
													 (yyvsp[-2].action),
													 (yyvsp[0].action));
									}
#line 6135 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 445:
#line 2090 "cfg.y" /* yacc.c:1646  */
    { mk_action2( (yyval.action), WHILE_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 (yyvsp[-2].expr),
													 (yyvsp[0].action));
									}
#line 6146 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 446:
#line 2098 "cfg.y" /* yacc.c:1646  */
    {
					if ((yyvsp[-4].specval)->type != PVT_SCRIPTVAR &&
					    (yyvsp[-4].specval)->type != PVT_AVP &&
						pv_type((yyvsp[-4].specval)->type) != PVT_JSON) {
						yyerror("\nfor-each statement: only \"var\", \"avp\" "
					            "and \"json\" iterators are supported!");
					}

					mk_action3( (yyval.action), FOR_EACH_T,
					            SCRIPTVAR_ST,
					            SCRIPTVAR_ST,
					            ACTIONS_ST,
					            (yyvsp[-4].specval),
					            (yyvsp[-2].specval),
					            (yyvsp[0].action));
					}
#line 6167 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 447:
#line 2116 "cfg.y" /* yacc.c:1646  */
    {
											mk_action2( (yyval.action), SWITCH_T,
														SCRIPTVAR_ST,
														ACTIONS_ST,
														(yyvsp[-4].specval),
														(yyvsp[-1].action));
									}
#line 6179 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 448:
#line 2125 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 6185 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 449:
#line 2126 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[0].action); }
#line 6191 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 450:
#line 2128 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 6197 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 451:
#line 2129 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 6203 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 452:
#line 2132 "cfg.y" /* yacc.c:1646  */
    { mk_action2( (yyval.action), CASE_T,
													NUMBER_ST,
													ACTIONS_ST,
													(void*)(yyvsp[-2].intval),
													(yyvsp[0].action));
											}
#line 6214 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 453:
#line 2138 "cfg.y" /* yacc.c:1646  */
    { mk_action2( (yyval.action), CASE_T,
													NUMBER_ST,
													ACTIONS_ST,
													(void*)(yyvsp[-1].intval),
													NULL);
							}
#line 6225 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 454:
#line 2144 "cfg.y" /* yacc.c:1646  */
    { mk_action2( (yyval.action), CASE_T,
													STR_ST,
													ACTIONS_ST,
													(void*)(yyvsp[-2].strval),
													(yyvsp[0].action));
											}
#line 6236 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 455:
#line 2150 "cfg.y" /* yacc.c:1646  */
    { mk_action2( (yyval.action), CASE_T,
													STR_ST,
													ACTIONS_ST,
													(void*)(yyvsp[-1].strval),
													NULL);
							}
#line 6247 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 456:
#line 2158 "cfg.y" /* yacc.c:1646  */
    { mk_action1( (yyval.action), DEFAULT_T,
													ACTIONS_ST, (yyvsp[0].action));
									}
#line 6255 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 457:
#line 2161 "cfg.y" /* yacc.c:1646  */
    { mk_action1( (yyval.action), DEFAULT_T, ACTIONS_ST, NULL); }
#line 6261 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 458:
#line 2164 "cfg.y" /* yacc.c:1646  */
    {
										elems[1].type = STR_ST;
										elems[1].u.data = (yyvsp[0].strval);
										(yyval.intval)=1;
										}
#line 6271 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 459:
#line 2169 "cfg.y" /* yacc.c:1646  */
    {
										if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
											yyerror("too many arguments "
												"in function\n");
											(yyval.intval)=0;
										}
										elems[(yyvsp[-2].intval)+1].type = STR_ST;
										elems[(yyvsp[-2].intval)+1].u.data = (yyvsp[0].strval);
										(yyval.intval)=(yyvsp[-2].intval)+1;
										}
#line 6286 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 460:
#line 2179 "cfg.y" /* yacc.c:1646  */
    {
										elems[1].type = NULLV_ST;
										elems[1].u.data = NULL;
										elems[2].type = NULLV_ST;
										elems[2].u.data = NULL;
										(yyval.intval)=2;
										}
#line 6298 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 461:
#line 2186 "cfg.y" /* yacc.c:1646  */
    {
										elems[1].type = NULLV_ST;
										elems[1].u.data = NULL;
										elems[2].type = STR_ST;
										elems[2].u.data = (yyvsp[0].strval);
										(yyval.intval)=2;
										}
#line 6310 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 462:
#line 2193 "cfg.y" /* yacc.c:1646  */
    {
										if ((yyvsp[-1].intval)+1>=MAX_ACTION_ELEMS) {
											yyerror("too many arguments "
												"in function\n");
											(yyval.intval)=0;
										}
										elems[(yyvsp[-1].intval)+1].type = NULLV_ST;
										elems[(yyvsp[-1].intval)+1].u.data = NULL;
										(yyval.intval)=(yyvsp[-1].intval)+1;
										}
#line 6325 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 463:
#line 2203 "cfg.y" /* yacc.c:1646  */
    {
										elems[1].type = NUMBER_ST;
										elems[1].u.number = (yyvsp[0].intval);
										(yyval.intval)=1;
										}
#line 6335 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 464:
#line 2208 "cfg.y" /* yacc.c:1646  */
    {
										elems[1].type = NULLV_ST;
										elems[1].u.data = NULL;
										elems[2].type = NUMBER_ST;
										elems[2].u.number = (yyvsp[0].intval);
										(yyval.intval)=2;
										}
#line 6347 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 465:
#line 2215 "cfg.y" /* yacc.c:1646  */
    {
										if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
											yyerror("too many arguments "
												"in function\n");
											(yyval.intval)=0;
										}
										elems[(yyvsp[-2].intval)+1].type = NUMBER_ST;
										elems[(yyvsp[-2].intval)+1].u.number = (yyvsp[0].intval);
										(yyval.intval)=(yyvsp[-2].intval)+1;
										}
#line 6362 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 466:
#line 2225 "cfg.y" /* yacc.c:1646  */
    {
										elems[1].type = SCRIPTVAR_ST;
										elems[1].u.data = (yyvsp[0].specval);
										(yyval.intval)=1;
										}
#line 6372 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 467:
#line 2230 "cfg.y" /* yacc.c:1646  */
    {
										elems[1].type = NULLV_ST;
										elems[1].u.data = NULL;
										elems[2].type = SCRIPTVAR_ST;
										elems[2].u.data = (yyvsp[0].specval);
										(yyval.intval)=2;
										}
#line 6384 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 468:
#line 2237 "cfg.y" /* yacc.c:1646  */
    {
										if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
											yyerror("too many arguments "
												"in function\n");
											(yyval.intval)=0;
										}
										elems[(yyvsp[-2].intval)+1].type = SCRIPTVAR_ST;
										elems[(yyvsp[-2].intval)+1].u.data = (yyvsp[0].specval);
										(yyval.intval)=(yyvsp[-2].intval)+1;
										}
#line 6399 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 469:
#line 2249 "cfg.y" /* yacc.c:1646  */
    {
						route_elems[0].type = STRING_ST;
						route_elems[0].u.string = (yyvsp[0].strval);
						(yyval.intval)=1;
			}
#line 6409 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 470:
#line 2254 "cfg.y" /* yacc.c:1646  */
    {
						route_elems[0].type = NUMBER_ST;
						route_elems[0].u.number = (long)(yyvsp[0].intval);
						(yyval.intval)=1;
			}
#line 6419 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 471:
#line 2259 "cfg.y" /* yacc.c:1646  */
    {
						route_elems[0].type = NULLV_ST;
						route_elems[0].u.data = 0;
						(yyval.intval)=1;
			}
#line 6429 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 472:
#line 2264 "cfg.y" /* yacc.c:1646  */
    {
						route_elems[0].type = SCRIPTVAR_ST;
						route_elems[0].u.data = (yyvsp[0].specval);
						(yyval.intval)=1;
			}
#line 6439 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 473:
#line 2269 "cfg.y" /* yacc.c:1646  */
    {
						if ((yyvsp[-2].intval)>=MAX_ACTION_ELEMS) {
							yyerror("too many arguments in function\n");
							(yyval.intval)=-1;
						} else {
							route_elems[(yyvsp[-2].intval)].type = STRING_ST;
							route_elems[(yyvsp[-2].intval)].u.data = (yyvsp[0].strval);
							(yyval.intval)=(yyvsp[-2].intval)+1;
						}
			}
#line 6454 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 474:
#line 2279 "cfg.y" /* yacc.c:1646  */
    {
						if ((yyvsp[-2].intval)>=MAX_ACTION_ELEMS) {
							yyerror("too many arguments in function\n");
							(yyval.intval)=-1;
						} else {
							route_elems[(yyvsp[-2].intval)].type = NUMBER_ST;
							route_elems[(yyvsp[-2].intval)].u.data = (void*)(long)(yyvsp[0].intval);
							(yyval.intval)=(yyvsp[-2].intval)+1;
						}
			}
#line 6469 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 475:
#line 2289 "cfg.y" /* yacc.c:1646  */
    {
						if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
							yyerror("too many arguments in function\n");
							(yyval.intval)=-1;
						} else {
							route_elems[(yyvsp[-2].intval)].type = SCRIPTVAR_ST;
							route_elems[(yyvsp[-2].intval)].u.data = (yyvsp[0].specval);
							(yyval.intval)=(yyvsp[-2].intval)+1;
						}
			}
#line 6484 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 476:
#line 2299 "cfg.y" /* yacc.c:1646  */
    {
						if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
							yyerror("too many arguments in function\n");
							(yyval.intval)=-1;
						} else {
							route_elems[(yyvsp[-2].intval)].type = NULLV_ST;
							route_elems[(yyvsp[-2].intval)].u.data = 0;
							(yyval.intval)=(yyvsp[-2].intval)+1;
						}
			}
#line 6499 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 477:
#line 2311 "cfg.y" /* yacc.c:1646  */
    {
				const acmd_export_t* acmd_tmp=find_mod_acmd_export_t((yyvsp[-2].strval));
				if (acmd_tmp==0){
					yyerrorf("unknown async command <%s>, "
						"missing loadmodule?", (yyvsp[-2].strval));
					(yyval.action)=0;
				}else{
					if (check_acmd_call_params(acmd_tmp,elems,0)<0) {
						yyerrorf("too few parameters "
							"for command <%s>\n", (yyvsp[-2].strval));
						(yyval.action)=0;
					} else {
						elems[0].type = ACMD_ST;
						elems[0].u.data_const = acmd_tmp;
						mk_action_((yyval.action), AMODULE_T, 1, elems);
					}
				}
			}
#line 6522 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 478:
#line 2329 "cfg.y" /* yacc.c:1646  */
    {
				const acmd_export_t* acmd_tmp=find_mod_acmd_export_t((yyvsp[-3].strval));
				if (acmd_tmp==0){
					yyerrorf("unknown async command <%s>, "
						"missing loadmodule?", (yyvsp[-3].strval));
					(yyval.action)=0;
				}else{
					rc = check_acmd_call_params(acmd_tmp,elems,(yyvsp[-1].intval));
					switch (rc) {
					case -1:
						yyerrorf("too few parameters "
							"for async command <%s>\n", (yyvsp[-3].strval));
						(yyval.action)=0;
						break;
					case -2:
						yyerrorf("too many parameters "
							"for async command <%s>\n", (yyvsp[-3].strval));
						(yyval.action)=0;
						break;
					case -3:
						yyerrorf("mandatory parameter "
							" omitted for async command <%s>\n", (yyvsp[-3].strval));
						(yyval.action)=0;
						break;
					default:
						elems[0].type = ACMD_ST;
						elems[0].u.data_const = acmd_tmp;
						mk_action_((yyval.action), AMODULE_T, (yyvsp[-1].intval)+1, elems);
					}
				}
			}
#line 6558 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 479:
#line 2360 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.action)=0;
				yyerrorf("bad arguments for command <%s>", (yyvsp[-3].strval));
			}
#line 6567 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 480:
#line 2364 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.action)=0;
				yyerrorf("bare word <%s> found, command calls need '()'", (yyvsp[-1].strval));
			}
#line 6576 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 481:
#line 2370 "cfg.y" /* yacc.c:1646  */
    {
			mk_action2( (yyval.action), ASSERT_T, EXPR_ST, STRING_ST, (yyvsp[-3].expr), (yyvsp[-1].strval));
			}
#line 6584 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 482:
#line 2373 "cfg.y" /* yacc.c:1646  */
    {mk_action0( (yyval.action), DROP_T); }
#line 6590 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 483:
#line 2374 "cfg.y" /* yacc.c:1646  */
    {mk_action0( (yyval.action), DROP_T); }
#line 6596 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 484:
#line 2375 "cfg.y" /* yacc.c:1646  */
    {mk_action0( (yyval.action), EXIT_T); }
#line 6602 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 485:
#line 2376 "cfg.y" /* yacc.c:1646  */
    {mk_action0( (yyval.action), EXIT_T); }
#line 6608 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 486:
#line 2378 "cfg.y" /* yacc.c:1646  */
    {mk_action1( (yyval.action), RETURN_T, SCRIPTVAR_ST, (void*)(yyvsp[0].specval)); }
#line 6614 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 487:
#line 2380 "cfg.y" /* yacc.c:1646  */
    {mk_action1( (yyval.action), RETURN_T, SCRIPTVAR_ST, (void*)(yyvsp[-1].specval)); }
#line 6620 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 488:
#line 2382 "cfg.y" /* yacc.c:1646  */
    {mk_action1( (yyval.action), RETURN_T, NUMBER_ST, (void*)(yyvsp[0].intval)); }
#line 6626 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 489:
#line 2384 "cfg.y" /* yacc.c:1646  */
    {mk_action1( (yyval.action), RETURN_T, NUMBER_ST, (void*)(yyvsp[-1].intval)); }
#line 6632 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 490:
#line 2386 "cfg.y" /* yacc.c:1646  */
    {mk_action1( (yyval.action), RETURN_T, NUMBER_ST, (void*)1); }
#line 6638 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 491:
#line 2387 "cfg.y" /* yacc.c:1646  */
    {mk_action1( (yyval.action), RETURN_T, NUMBER_ST, (void*)1); }
#line 6644 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 492:
#line 2388 "cfg.y" /* yacc.c:1646  */
    {mk_action2( (yyval.action), LOG_T, NUMBER_ST,
													STRING_ST,(void*)4,(yyvsp[-1].strval));
									}
#line 6652 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 493:
#line 2391 "cfg.y" /* yacc.c:1646  */
    {mk_action2( (yyval.action), LOG_T,
																NUMBER_ST,
																STRING_ST,
																(void*)(yyvsp[-3].intval),
																(yyvsp[-1].strval));
												}
#line 6663 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 494:
#line 2397 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 6669 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 495:
#line 2398 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad log"
									"argument"); }
#line 6676 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 496:
#line 2400 "cfg.y" /* yacc.c:1646  */
    {mk_action2( (yyval.action), ERROR_T,
																STRING_ST,
																STRING_ST,
																(yyvsp[-3].strval),
																(yyvsp[-1].strval));
												  }
#line 6687 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 497:
#line 2406 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 6693 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 498:
#line 2407 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad error"
														"argument"); }
#line 6700 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 499:
#line 2409 "cfg.y" /* yacc.c:1646  */
    {
						mk_action2( (yyval.action), ROUTE_T, (yyvsp[-1].intval), 0, rn_tmp.data, 0);
					}
#line 6708 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 500:
#line 2413 "cfg.y" /* yacc.c:1646  */
    {
						if ((yyvsp[-1].intval) <= 0) yyerror("too many route parameters");

						/* duplicate the list */
						a_tmp = pkg_malloc((yyvsp[-1].intval) * sizeof(action_elem_t));
						if (!a_tmp) {
							yyerror("no more pkg memory");
							YYABORT;
						}
						memcpy(a_tmp, route_elems, (yyvsp[-1].intval)*sizeof(action_elem_t));

						mk_action3( (yyval.action), ROUTE_T, (yyvsp[-3].intval),	/* route idx */
							NUMBER_ST,					/* number of params */
							SCRIPTVAR_ST,				/* parameters */
							rn_tmp.data,
							(void*)(long)(yyvsp[-1].intval),
							(void*)a_tmp);
					}
#line 6731 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 501:
#line 2432 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 6737 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 502:
#line 2433 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad route"
						"argument"); }
#line 6744 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 503:
#line 2435 "cfg.y" /* yacc.c:1646  */
    {
								const cmd_export_t* cmd_tmp=find_cmd_export_t((yyvsp[-2].strval), rt);
								if (cmd_tmp==0){
									if (find_cmd_export_t((yyvsp[-2].strval), 0)) {
										yyerrorf("Command <%s> cannot be "
											"used in the block\n", (yyvsp[-2].strval));
									} else {
										yyerrorf("unknown command <%s>, "
											"missing loadmodule?", (yyvsp[-2].strval));
									}
									(yyval.action)=0;
								}else{
									if (check_cmd_call_params(cmd_tmp,elems,0)<0) {
										yyerrorf("too few parameters "
											"for command <%s>\n", (yyvsp[-2].strval));
										(yyval.action)=0;
									} else {
										elems[0].type = CMD_ST;
										elems[0].u.data_const = cmd_tmp;
										mk_action_((yyval.action), CMD_T, 1, elems);
									}
								}
							}
#line 6772 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 504:
#line 2458 "cfg.y" /* yacc.c:1646  */
    {
								const cmd_export_t* cmd_tmp=find_cmd_export_t((yyvsp[-3].strval), rt);
								if (cmd_tmp==0){
									if (find_cmd_export_t((yyvsp[-3].strval), 0)) {
										yyerrorf("Command <%s> cannot be "
											"used in the block\n", (yyvsp[-3].strval));
									} else {
										yyerrorf("unknown command <%s>, "
											"missing loadmodule?", (yyvsp[-3].strval));
									}
									(yyval.action)=0;
								}else{
									rc = check_cmd_call_params(cmd_tmp,elems,(yyvsp[-1].intval));
									switch (rc) {
									case -1:
										yyerrorf("too few parameters "
											"for command <%s>\n", (yyvsp[-3].strval));
										(yyval.action)=0;
										break;
									case -2:
										yyerrorf("too many parameters "
											"for command <%s>\n", (yyvsp[-3].strval));
										(yyval.action)=0;
										break;
									case -3:
										yyerrorf("mandatory parameter "
											"omitted for command <%s>\n", (yyvsp[-3].strval));
										(yyval.action)=0;
										break;
									default:
										elems[0].type = CMD_ST;
										elems[0].u.data_const = cmd_tmp;
										mk_action_((yyval.action), CMD_T, (yyvsp[-1].intval)+1, elems);
									}
								}
							}
#line 6813 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 505:
#line 2494 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerrorf("bad arguments for "
												"command <%s>", (yyvsp[-3].strval)); }
#line 6820 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 506:
#line 2496 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0;
			yyerrorf("bare word <%s> found, command calls need '()'", (yyvsp[-1].strval));
			}
#line 6828 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 507:
#line 2499 "cfg.y" /* yacc.c:1646  */
    {
				mk_action1((yyval.action), XDBG_T, STR_ST, (yyvsp[-1].strval));	}
#line 6835 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 508:
#line 2501 "cfg.y" /* yacc.c:1646  */
    {
				mk_action1((yyval.action), XDBG_T, STR_ST, (yyvsp[-1].strval));	}
#line 6842 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 509:
#line 2503 "cfg.y" /* yacc.c:1646  */
    {
				mk_action1((yyval.action), XLOG_T, STR_ST, (yyvsp[-1].strval)); }
#line 6849 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 510:
#line 2505 "cfg.y" /* yacc.c:1646  */
    {
				mk_action1((yyval.action), XLOG_T, STR_ST, (yyvsp[-1].strval)); }
#line 6856 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 511:
#line 2507 "cfg.y" /* yacc.c:1646  */
    {
				mk_action2((yyval.action), XLOG_T, STR_ST, STR_ST, (yyvsp[-3].strval), (yyvsp[-1].strval)); }
#line 6863 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 512:
#line 2509 "cfg.y" /* yacc.c:1646  */
    {
				mk_action2((yyval.action), XLOG_T, STR_ST, STR_ST, (yyvsp[-3].strval), (yyvsp[-1].strval)); }
#line 6870 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 513:
#line 2511 "cfg.y" /* yacc.c:1646  */
    {
				rt_ref = ref_script_route_by_name( (yyvsp[-1].strval), sroutes->request,
					RT_NO, REQUEST_ROUTE, 0);
				if (rt_ref==NULL) yyerror("fail to create route reference");
				mk_action2((yyval.action), ASYNC_T, ACTIONS_ST, ROUTE_REF_ST,
						(yyvsp[-3].action), (void*)rt_ref);
				}
#line 6882 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 514:
#line 2518 "cfg.y" /* yacc.c:1646  */
    {
				rt_ref = ref_script_route_by_name( (yyvsp[-3].strval), sroutes->request,
					RT_NO, REQUEST_ROUTE, 0);
				if (rt_ref==NULL) yyerror("fail to create route reference");
				mk_action3((yyval.action), ASYNC_T, ACTIONS_ST, ROUTE_REF_ST, NUMBER_ST,
						(yyvsp[-5].action), (void*)rt_ref, (void*)(long)(yyvsp[-1].intval));
				}
#line 6894 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 515:
#line 2525 "cfg.y" /* yacc.c:1646  */
    {
				rt_ref = ref_script_route_by_name( (yyvsp[-3].strval), sroutes->request,
					RT_NO, REQUEST_ROUTE, 0);
				if (rt_ref==NULL) yyerror("fail to create route reference");
				mk_action3((yyval.action), LAUNCH_T, ACTIONS_ST, ROUTE_REF_ST, STRING_ST,
						(yyvsp[-5].action), (void*)rt_ref, (yyvsp[-1].strval));
				}
#line 6906 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 516:
#line 2532 "cfg.y" /* yacc.c:1646  */
    {
				rt_ref = ref_script_route_by_name( (yyvsp[-1].strval), sroutes->request,
					RT_NO, REQUEST_ROUTE, 0);
				if (rt_ref==NULL) yyerror("fail to create route reference");
				mk_action2((yyval.action), LAUNCH_T, ACTIONS_ST, ROUTE_REF_ST,
						(yyvsp[-3].action), (void*)rt_ref);
				}
#line 6918 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 517:
#line 2539 "cfg.y" /* yacc.c:1646  */
    {
				mk_action2((yyval.action), LAUNCH_T, ACTIONS_ST, ROUTE_REF_ST,
						(yyvsp[-1].action), (void*)NULL);
				}
#line 6927 "cfg.tab.c" /* yacc.c:1646  */
    break;


#line 6931 "cfg.tab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 2546 "cfg.y" /* yacc.c:1906  */


static inline void ALLOW_UNUSED warn(char* s)
{
	LM_WARN("warning in config file %s, line %d, column %d-%d: %s\n",
			get_cfg_file_name, line, startcolumn, column, s);
}

static void yyerror(char* s)
{
	cfg_dump_backtrace();
	LM_CRIT("parse error in %s:%d:%d-%d: %s\n",
			get_cfg_file_name, line, startcolumn, column, s);
	_cfg_dump_context(get_cfg_file_name, line, startcolumn, column, 1);
	cfg_errors++;
}

#define ERROR_MAXLEN 1024
static void yyerrorf(char *fmt, ...)
{
	char *tmp = pkg_malloc(ERROR_MAXLEN);
	va_list ap;
	va_start(ap, fmt);

	vsnprintf(tmp, ERROR_MAXLEN, fmt, ap);
	yyerror(tmp);

	pkg_free(tmp);
	va_end(ap);
}


static struct socket_id* mk_listen_id(char* host, enum sip_protos proto,
																	int port)
{
	struct socket_id* l;
	l=pkg_malloc(sizeof(struct socket_id));
	if (l==0){
		LM_CRIT("cfg. parser: out of memory.\n");
	}else{
		memset(l, 0, sizeof(*l));
		l->name     = host;
		l->proto    = proto;
		l->port     = port;
	}

	return l;
}

static void fill_socket_id(struct listen_param *param, struct socket_id *s)
{
	s->flags |= param->flags;
	s->workers = param->workers;
	s->auto_scaling_profile = param->auto_scaling_profile;
	if (param->socket)
		set_listen_id_adv(s, param->socket->name, param->socket->port);
	s->tag = param->tag;
}

static struct multi_str *new_string(char *s)
{
	struct multi_str *ms = pkg_malloc(sizeof(struct multi_str));
	if (!ms) {
		LM_CRIT("cfg. parser: out of memory.\n");
	}else{
		ms->s    = s;
		ms->next = NULL;
	}
	return ms;
}

static struct socket_id* set_listen_id_adv(struct socket_id* sock,
											char *adv_name,
											int adv_port)
{
	sock->adv_name=adv_name;
	sock->adv_port=adv_port;
	return sock;
}

static int parse_ipnet(char *in, int len, struct net **ipnet)
{
	char *p = NULL;
	str ip_s, mask_s;
	struct ip_addr *ip = NULL, *mask = NULL, *ip_tmp;
	int af;
	unsigned int bitlen;

	p = q_memchr(in, '.', len);
	if (p)
		af = AF_INET;
	else if (q_memchr(in, ':', len)) {
		af = AF_INET6;
	} else {
		LM_ERR("Not an IP");
		return -1;
	}

	p = q_memchr(in, '/', len);
	if (!p) {
		LM_ERR("No netmask\n");
		return -1;
	}
	ip_s.s = in;
	ip_s.len = p - in;

	mask_s.s = p + 1;
	mask_s.len = len - ip_s.len - 1;
	if (!mask_s.s || mask_s.len == 0) {
		LM_ERR("Empty netmask\n");
		return -1;
	}

	ip_tmp = (af == AF_INET) ? str2ip(&ip_s) : str2ip6(&ip_s);
	if (!ip_tmp) {
		LM_ERR("Invalid IP\n");
		return -1;
	}
	ip = pkg_malloc(sizeof *ip);
	if (!ip) {
		LM_CRIT("No more pkg memory\n");
		return -1;
	}
	memcpy(ip, ip_tmp, sizeof *ip);

	p = (af == AF_INET) ? q_memchr(p, '.', len-(p-in)+1) : q_memchr(p, ':', len-(p-in)+1);
	if (p) {
		ip_tmp = (af == AF_INET) ? str2ip(&mask_s) : str2ip6(&mask_s);
		if (!ip_tmp) {
			LM_ERR("Invalid netmask\n");
			return -1;
		}
		mask = pkg_malloc(sizeof *mask);
		if (!mask) {
			LM_CRIT("No more pkg memory\n");
			return -1;
		}
		memcpy(mask, ip_tmp, sizeof *mask);

		*ipnet = mk_net(ip, mask);
	} else {
		if (str2int(&mask_s, &bitlen) < 0) {
			LM_ERR("Invalid netmask bitlen\n");
			return -1;
		}

		*ipnet = mk_net_bitlen(ip, bitlen);
	}

	pkg_free(ip);
	pkg_free(mask);

	if (*ipnet == NULL)
			return -1;

	return 0;
}
